;1. routines which deal with using items
;2. special routines for displaying things in locations that change

;-----------------ACTION ROUTINES---------------



;-----------------LOCATION ROUTINES---------------
DoLocationCode
;perform code specific for each location
	
;find if code for current location exists
	LD A,(CurrentRoomNr)
	LD B,A
	LD DE,LocationCodeData-3
	
DoLocationCode2
	INC DE					;go to next code
	INC DE
	INC DE
	
	LD A,(DE)				;read location nr from location code list
	OR A
	JR Z,DisplayDisks		;0 end of list -> no code for current location exist
		
	CP B					;is this the code for current location?
	JR NZ,DoLocationCode2	;if no -> check next code
	
;code for current location found, read code address
	INC DE
	LD A,(DE)
	LD L,A
	
	INC DE
	LD A,(DE)
	LD H,A
	
	JP (HL)					;go to our code, after the code is done, RET is performed and program returns to location drawing
	
;-------------
DisplayDisks
;disk may be only in location, which doesn't have its code
	LD HL,DiskLocations
	LD DE,DisksStatus
DisplayDisks2
	LD A,(HL)
	OR A
	RET Z					;end of list- no disk in this location
	LD A,(CurrentRoomNr)
	CP (HL)					;is disk in this location?
	JR Z,DisplayDisks3		;yes, display it
	
	INC HL					;go to next disk data
	INC HL
	INC HL
	INC DE					;go to next disk status
	JR DisplayDisks2
	
DisplayDisks3
	LD A,(DE)
	OR A					;is disk already collected?
	RET NZ					;if so don't draw it

	INC HL
	LD D,(HL)				;read position
	INC HL
	LD E,(HL)
	EX DE,HL
;this is position where jetman must stand to pick up disk
;go 3 line down to get disk position
	LD B,3
DisplayDisks4	
	LD A,L
	ADD A,32
	LD L,A
	JR NC,DisplayDisks5
	LD A,H
	ADD A,8
	LD H,A
DisplayDisks5	
	DJNZ DisplayDisks4
	
	LD DE,Optidisk
	CALL DrawTile			;draw disk
	RET



	
	
;--------	
LocationCodeData
	.BYTE 4*16+14
	.WORD Fusebox_Code
	
	.BYTE 0*16+5
	.WORD A5Door_Code
	
	.BYTE 1*16+8
	.WORD B8Door_Code
	
	.BYTE 3*16+4
	.WORD Steelgate_Code
	
	.BYTE 3*16+10
	.WORD ElectroField_Code
	
	.BYTE 2*16+10
	.WORD ElectroField_Code2
	
	.BYTE 7*16+14
	.WORD Plant_Code
	
	.BYTE 4*16+11
	.WORD Cart1_Code
	
	.BYTE 5*16+14
	.WORD Cart2_Code
	
	.BYTE 4*16+1
	.WORD Tree_Code
	
	.BYTE 1*16+2
	.WORD DogCode
	
	.BYTE 2*16+2
	.WORD C2WallCode
	
	.BYTE 6*16+1
	.WORD G1WaterCode
	
	.BYTE 6*16+2
	.WORD G2G3G4WaterCode
	
	.BYTE 6*16+3
	.WORD G2G3G4WaterCode
	
	.BYTE 6*16+4
	.WORD G2G3G4WaterCode
	
	.BYTE 6*16+5
	.WORD G5WaterCode
	
	.BYTE 5*16+5
	.WORD F5WaterCode
	
	.BYTE 5*16+6
	.WORD F6WaterCode
	
	.BYTE 5*16+8
	.WORD F8Door_Code
	
	.BYTE 6*16+9
	.WORD G9Bridge_Code
	
	.BYTE 6*16+10
	.WORD G10G11Bridge_Code
	
	.BYTE 6*16+11
	.WORD G10G11Bridge_Code
	
	.BYTE 6*16+12
	.WORD G12Bridge_Code
	
	.BYTE 3*16+16
	.WORD D16Door_Code
	
	.BYTE 1*16+15
	.WORD RocksCode
	
	.BYTE 0
	
;---------------------------------
DiskLocations
	.BYTE 1*16+10,80,5;location number,jetman position to pick up
	.BYTE 2*16+14,72,80
	.BYTE 3*16+12,72,78
	.BYTE 2*16+7,80,21
	.BYTE 4*16+2,72,72
	.BYTE 4*16+6,72,149
	.BYTE 4*16+7,80,4
	.BYTE 7*16+16,80,27
	.BYTE 6*16+7,80,26
	.BYTE 0
	

;---------------------------------
;code for locations
Fusebox_Code
;draw fusebox open or locked
	LD DE,Fusebox_Locked
	LD A,(FuseboxStatus)
	OR A
	JR Z,Fusebox_Code2	
	LD DE,Fusebox_Open
	
Fusebox_Code2	
	LD HL,18612
	CALL DrawTile
	RET
	
;-----------
A5Door_Code
;draw door or not
	LD A,(A5DoorStatus)
	OR A
	RET NZ
	LD HL,72*256+228
	LD DE,DoorA5
	CALL DrawTile
	RET
		
;-----------
B8Door_Code
;draw door or not
	LD A,(B8DoorStatus)
	OR A
	RET NZ
	LD HL,72*256+207
	LD DE,Door2
	CALL DrawTile
	RET	
	
;-----------
ElectroField_Code
;draw forcefield or not
	LD A,(ElectroFieldStatus)
	OR A
	RET NZ
	LD HL,64*256+232
	LD DE,ElectroField
	LD BC,1*256+14
	CALL TileBlock
	RET
	
;-----------
ElectroField_Code2
;draw supply cable for electrofield or not
	LD A,(ElectroFieldStatus)
	OR A
	RET Z
	LD HL,80*256+41
	LD DE,EmptySpace
	CALL DrawTile
	RET				
	
;-----------
Steelgate_Code
;draw gate or not
	LD A,(SteelgateStatus)
	OR A
	RET NZ
	LD HL,64*256+198
	LD DE,SteelGate
	LD BC,1*256+7
	CALL TileBlock
	RET
	
;-----------
Plant_Code
;draw spiky plant or not
	LD A,(PlantStatus)
	OR A
	RET NZ
	LD HL,72*256+147
	LD DE,SpikyPlant
	LD BC,1*256+5
	CALL TileBlock
	RET
	
Cart1_Code
;draw cart at starting place or not
	LD A,(CartStatus)
	OR A
	RET NZ
	LD HL,72*256+202
	LD DE,Cart
	CALL DrawTile	
	RET
	
Cart2_Code
;draw wall at cart movement path or not (destroyed by cart)
	LD A,(CartStatus)
	OR A
	RET NZ
	
	LD HL,72*256+140
	LD DE,Brickwall1
	LD BC,3*256+4
	CALL TileBlock
	
	LD HL,72*256+142
	LD DE,Brickwall2
	CALL DrawTile	
	
	LD HL,80*256+12
	LD DE,Brickwall2
	CALL DrawTile	
	
	LD HL,80*256+80
	LD DE,Brickwall2
	CALL DrawTile
	
	RET

Tree_Code
;draw branch or not
	LD A,(TreeStatus)
	OR A
	RET NZ
	
	LD HL,72*256+138
	LD DE,Branch3
	LD BC,5*256+1
	CALL TileBlock
	
	LD HL,72*256+148
	LD DE,Branch4
	CALL DrawTile
	RET
	
C2WallCode
;draw wall at C2 or not
 	LD A,(C2WallStatus)
	OR A
	RET NZ
	
	LD DE,Brickwall1
	LD BC,2*256+3
	LD HL,80*256+22
	CALL TileBlock
	LD DE,Brickwall2
	LD HL, 80*256+86
	CALL DrawTile
	RET
	
DogCode
;draw inivisible barrier (dog blocking way or not)	
	LD A,(DogStatus)
	OR A
	RET NZ
	
	LD DE,SpaceBlock
	LD HL,16384+214
	LD BC,1*256+12
	CALL TileBlock
	RET
	
	
	
G1WaterCode	
;draw water at G1 or not
 LD A,(WaterStatus)
 OR A
 RET Z
 LD HL,80*256+98
 LD DE,Water
 LD BC,30*256+3
 CALL TileBlock
 RET
 
G2G3G4WaterCode	
;draw water at G2,G3,G4 or not
 LD A,(WaterStatus)
 OR A
 RET Z
 LD HL,80*256+96
 LD DE,Water
 LD BC,32*256+3
 CALL TileBlock
 RET
 
G5WaterCode	
;draw water at G2,G3,G4 or not
 LD A,(WaterStatus)
 OR A
 RET Z
 LD HL,80*256+96
 LD DE,Water
 LD BC,28*256+3
 CALL TileBlock
 RET
 
 
F5WaterCode	
;draw water at F5 or not
 LD A,(WaterStatus)
 OR A
 RET NZ
 LD HL,72*256+196
 LD DE,Water
 LD BC,28*256+8
 CALL TileBlock
 RET 
 
 
F6WaterCode	
;draw water at F5 or not
 LD A,(WaterStatus)
 OR A
 RET NZ
 LD HL,72*256+192
 LD DE,Water
 LD BC,32*256+8
 CALL TileBlock
 
;don't allow to go further 
 LD HL,80*256+126
 LD DE,WaterBlock
 CALL DrawTile
 RET
 
F8Door_Code 
 ;door destroyed or not
 LD A,(F8DoorStatus)
 OR A
 RET Z
 LD HL,18432+245		;empty hole after door destroying
 LD DE,EmptySpace
 LD BC,4*256+7
 CALL TileBlock
 RET
 
 
 
G9Bridge_Code
 LD A,(BridgeStatus)
 OR A
 RET Z
 LD HL,72*256+142
 LD DE,Bridge
 LD BC,9*256+1
 CALL TileBlock
 RET
 
G10G11Bridge_Code
 LD A,(BridgeStatus)
 OR A
 JR NZ,G10G11Bridge_Code2
;draw blocking laser
	LD HL,18432+52
	LD DE,BigLaser1
	CALL DrawTile
	LD HL,18432+84
	LD DE,BigLaser2
	LD BC,1*256+12
	CALL TileBlock
	RET
G10G11Bridge_Code2
 LD HL,72*256+128
 LD DE,Bridge
 LD BC,16*256+1
 CALL TileBlock
 RET
 
G12Bridge_Code
 LD A,(BridgeStatus)
 OR A
 RET Z
 LD HL,72*256+128
 LD DE,Bridge
 LD BC,13*256+1
 CALL TileBlock
 RET
 
D16Door_Code
 LD A,(D16DoorStatus)
 OR A
 RET NZ
 LD HL,72*256+9
 LD DE,Door2
 CALL DrawTile
 RET
 
RocksCode
 LD A,(RocksStatus)
 OR A
 RET NZ
 
 LD HL,80*256+92
 LD DE,Boulder
 LD BC,2*256+2
 CALL TileBlock
 LD HL,80*256+30
 LD DE,Boulder
 CALL DrawTile
 LD HL,80*256+154
 LD DE,Boulder
 CALL DrawTile
 RET	

;-------------------

	

;graphics for special things

Fusebox_Open
	.BYTE 3,3
	.BYTE	255,128,191,160,160,160,166,169
	.BYTE	255,  0,255,  0,  0,  0, 49, 74
	.BYTE	255,  1,253, 13,  9, 13,141, 77
	.BYTE	171,166,160,160,160,160,166,169
	.BYTE	 90, 49,  0,  0,  0,  0, 49, 74
	.BYTE	201,141,  9, 13,  9,  5,137, 69
	.BYTE	171,166,160,160,191,187,128,255
	.BYTE	 90, 49,  0,  0,250, 85,  0,255
	.BYTE	201,133,  9,  5,169, 85,  1,255
	.BYTE	 69, 69, 69, 69, 5, 69, 69, 69,69

Fusebox_Locked
	.BYTE 3,3
	.BYTE	255,128,191,177,172,154,150,172
	.BYTE	255,  0,255,255,255,255,255,255
	.BYTE	255,  1,253,197,177,105, 89,177
	.BYTE	177,191,191,191,191,191,191,177
	.BYTE	255,255,255,255,255,255,255,255
	.BYTE	197,253,249,245,249,245,233,197
	.BYTE	172,154,150,172,177,191,128,255
	.BYTE	255,255,255,254,245,106,  0,255
	.BYTE	177,105, 89,177, 69,169,  1,255
	.BYTE	 69, 69, 69, 69, 69, 69, 69, 69,69
	
DoorA5
	.BYTE 1,7
	.BYTE	255,  1,  1,121, 81,105, 81,105
	.BYTE	 89,121,113,105, 81,105, 81,105
	.BYTE	 81,105, 81,105, 89,121,113,105
	.BYTE	 81,105, 81,105, 81,105, 81,105
	.BYTE	 89,121,113,105, 81,105, 81,105
	.BYTE	 81,105, 89,121,113,105, 81,105
	.BYTE	 81,105, 81,121,  1,  1,  1,255
	.BYTE	 24, 24, 24, 24, 24, 24, 24
	
SteelGate
	.BYTE 2,2
	.BYTE	232, 80,224, 80,224, 81,224, 80
	.BYTE	 17, 17, 21, 17,145, 21, 17, 17
	.BYTE	232, 80,232, 80,224, 81,234, 80
	.BYTE	 53, 81, 17, 21, 17, 17, 21, 17
	.BYTE	  8,  8,  8,  8
	
ElectroField
	.BYTE 2,1
	.BYTE	255,  0,255,255,255,  0,255,255
	.BYTE	255,  0,255,255,255,  0,255,255
	.BYTE	 96, 96
	
SpikyPlant
	.BYTE 2,2
	.BYTE	254,254,252, 12,153,216,241,242
	.BYTE	119,183,119,239,111,220, 81,211
	.BYTE	241,242,241,240,249,232,197,156
	.BYTE	215,223,223,223, 95,235,104,169
	.BYTE	 96, 32, 96, 32
	
WaterBlock
	.BYTE 1,1
	.BYTE 16
	.BYTE 72
	
Bridge
	.BYTE 2,4
	.BYTE	255,224,207,159,183,191,175,175
	.BYTE	255,  3,249,236,214,238,246,254
	.BYTE	171,173,171,173,171,173,171,173
	.BYTE	254,254,254,254,254,254,254,254
	.BYTE	171,173,171,173,170,173,170,173
	.BYTE	254,254,254,254,254,254,254,254
	.BYTE	170,173,150,217,206,231,240,255
	.BYTE	254, 94,188,253, 25,243,  7,255
	.BYTE	 72, 72, 80, 72, 24, 80, 89, 89
	
BigLaser1
	.BYTE 2,1
	.BYTE	240,232,216,220,180,166,178,171
	.BYTE	 87, 87, 59, 43,107, 93,205,149
	.BYTE	 88, 24
BigLaser2
	.BYTE 2,1
	.BYTE	176,168,176,168,176,168,176,168
	.BYTE	 45, 21, 45, 21, 45, 21, 45, 21
	.BYTE	 88, 24
	
	
	
Optidisk
	.BYTE 3,3
	.BYTE	  0,  1,  7, 15, 31, 63, 63,127
	.BYTE	126,255,255,255,255,255,255,129
	.BYTE	  0,128,224,240,248,236,244,254
	.BYTE	127,254,254,254,254,254,254,127
	.BYTE	 60,126,231,195,195,231,126, 60
	.BYTE	254,127,125,123,125,123,127,246
	.BYTE	127, 63, 63, 31, 15,  7,  1,  0
	.BYTE	129,255,255,255,245,235,255,126
	.BYTE	238,244,236,216,240,224,128,  0
	.BYTE	 69, 69,  5, 69, 65,  5,  5,  5
	.BYTE	  5