
PressFire
	LD A,(FlyStatus)				;no actions when flying
	OR A
	RET NZ
	
	LD A,(CurrentItem)				;energy potion can be used anywhere, so chack it now
	CP 16							;potion?
	JR NZ,CheckAction
	LD A,99							;restore energy
	LD (Energy),A
	CALL DrawMenuNumbers1
	CALL KillCurrentItem
	LD A,9
	CALL TypeMessage
	RET
	

CheckAction
	LD DE,ActionsData
CheckAction2
	LD A,(DE)
	OR A
	JP Z,CollectDisks				;0-end of actions list
									;no action was performed -> go to disk collecting and maybe later itemp dropping/picking
	
;compare location	
	LD B,A
	LD A,(CurrentRoomNr)
	CP B							;is current location and location of currently checked action the same
	JR NZ,CheckAction4				;it isn't -> go to next action	
	
;compare position
	INC DE
	LD HL,(OldJetmanPos)
	LD A,(DE)						;compare H of jetman position and action position (must be equal)
	CP H
	JR NZ,CheckAction5				;non equal H,skip action
	INC DE
	LD A,(DE)
	CP L
	JR Z,CheckAction3				;action allowed
	DEC L							;check not only exact L position, but also L-1 and L+1
	CP L
	JR Z,CheckAction3				;action allowed
	INC L
	INC L
	CP L
	JR Z,CheckAction3				;action allowed

	JR CheckAction6					;bad L position, action skipped		

;action allowed	
CheckAction3
	INC DE
	
	LD A,(DE)						;load action code adress
	LD L,A
	INC DE
	LD A,(DE)
	LD H,A
	JP (HL)							;go to action code
	
	
CheckAction4
	INC DE
CheckAction5
	INC DE
CheckAction6
	INC DE
	INC DE
	INC DE
	JR CheckAction2
	
;--------------------------
CollectDisks
	LD HL,DiskLocations
	LD B,1							;number of currently checked disk
	
CollectDisks2
	LD C,(HL)						;read  number of lacation in current checked disk data
	LD A,(CurrentRoomNr)			
	CP C							;is there a disk in current location?
	JR NZ,CollectDisks4				;no disk, go to next disk data
	
;there is a disk in current location, compare position	
	LD DE,(OldJetmanPos)
	INC HL
	LD A,(HL)
	CP D
	JR NZ,CollectDisks5				;H position not equal
	INC HL
	LD A,(HL)
	CP E
	JR Z,CollectDisks25				;equal position confirmed
	DEC E
	CP E
	JR Z,CollectDisks25				;some position tolerance
	INC E
	INC E 
	CP E
	JR Z,CollectDisks25
	
	JR CollectDisks6				;L position not equal

CollectDisks25	
;position equal
	LD HL,DisksStatus-1	
CollectDisks3
	INC HL							;go to disk number B status and check if it was collected
	DJNZ CollectDisks3
	
	LD A,(HL)
	OR A
	JP NZ,PickAndDropItems			;disk already collected, do nothing

;collect disk
	INC (HL)						;change collected disk status to already collected
	LD HL,Disks
	INC (HL)						;change number of collected disks

;refresh current location and menu
	CALL DrawMenuNumbers
	CALL MenuSound
	
	XOR A
	LD (UpdateEnemy),A			;don't set enemy position to initial one
								;let him stay at his current position
	LD HL,(CurrentLocation)
	CALL DrawRoom
	CALL ChangeRoom2
	RET
	
	
	
CollectDisks4						;go to next disk data
	INC HL
CollectDisks5
	INC HL
CollectDisks6
	INC HL
	INC B
	LD A,B
	CP 10							;nine disks in the game
	JR NZ,CollectDisks2
								
	
CollectDisks7	
	JP PickAndDropItems
	
	
	
ActionsData
	.BYTE 1
	.BYTE 80,25
	.WORD SeeNote1
	
	.BYTE 1*16+12
	.BYTE 80,16
	.WORD SeeNote2
	
	.BYTE 1*16+3
	.BYTE 80,22
	.WORD SeeNote3
	
	.BYTE 6*16+2
	.BYTE 64,199
	.WORD SeeNote4

	

	.BYTE 5				;room number
	.BYTE 80,1			;jetman HL position to preform action
	.WORD OpenDoorA5	;code executed	
	
	.BYTE 24			
	.BYTE 80,12			
	.WORD OpenDoorB8	
	
	.BYTE 4*16+14			
	.BYTE 72,211			
	.WORD ChangeFuse
	
	.BYTE 4*16+1
	.BYTE 64,200
	.WORD CutBranch
	
	.BYTE 1*16+2
	.BYTE 80,23
	.WORD MeetDog
	
	.BYTE 1*16+2
	.BYTE 80,12
	.WORD UseComputer
	
	.BYTE 3*16+4
	.BYTE 80,8
	.WORD OpenSteelgate
	
	.BYTE 2*16+10
	.BYTE 80,8
	.WORD RemoveField
	
	.BYTE 7*16+14
	.BYTE 80,20
	.WORD RemovePlant
	
	.BYTE 4*16+11
	.BYTE 72,138
	.WORD MoveCart
	
	.BYTE 2*16+1
	.BYTE 72,86
	.WORD C1GoDoor
	
	.BYTE 2*16+2
	.BYTE 72,66
	.WORD C2GoDoor
	
	.BYTE 2*16+2
	.BYTE 80,18
	.WORD RemoveWallC2
	
	.BYTE 5*16+5
	.BYTE 64,193
	.WORD PumpWater
	
	.BYTE 0*16+3
	.BYTE 80,8
	.WORD FillFuel
	
	.BYTE 5*16+8
	.BYTE 80,21
	.WORD DestroyDoorF8
	
	.BYTE 6*16+8
	.BYTE 80,21
	.WORD GoDoorG8
	
	.BYTE 6*16+9
	.BYTE 64,202
	.WORD MakeBridge
	
	.BYTE 6*16+13
	.BYTE 80,17
	.WORD GoDoorG13
	
	.BYTE 7*16+13
	.BYTE 80,17
	.WORD GoDoorH13
	
	.BYTE 3*16+16
	.BYTE 72,70
	.WORD OpenDoorD16
	
	.BYTE 1*16+15
	.BYTE 80,23
	.WORD RemoveRocks
	
	.BYTE 1*16+7
	.BYTE 80,13
	.WORD GoB7Door
	
	.BYTE 2*16+6
	.BYTE 80,15
	.WORD GoC6Door
	
	.BYTE 2*16+7
	.BYTE 80,14
	.WORD GoC7Door
	
	.BYTE 3*16+6
	.BYTE 80,15
	.WORD GoD6Door
	
	.BYTE 4*16+15
	.BYTE 80,17
	.WORD ActivateLift
	
	.BYTE 4*16+15
	.BYTE 72,196
	.WORD E15GoLift
	
	.BYTE 3*16+15
	.BYTE 72,68
	.WORD D15GoLift
	
	.BYTE 1*16+16
	.BYTE 80,14
	.WORD FlyAway
	
	
	
	
	
	.BYTE 0

;-------------------ACTIONS CODE--------------------

DrinkPotion	

SeeNote1
	LD A,1
	CALL TypeMessage
	RET
SeeNote2
	LD A,2
	CALL TypeMessage
	RET
SeeNote3
	LD A,3
	CALL TypeMessage
	RET
SeeNote4
	LD A,4
	CALL TypeMessage
	RET


OpenDoorA5
	LD HL,A5DoorStatus
	LD A,(HL)
	OR A
	RET NZ				;door already opened
	
	LD A,(CurrentItem)
	CP 10				;key?
	RET NZ
	
	INC (HL)			;change status - open door
	CALL KillCurrentItem
	LD A,5
	CALL TypeMessage	;message+screen refresh
	RET					

;-----	
OpenDoorB8
	LD HL,B8DoorStatus
	LD A,(HL)
	OR A
	RET NZ				;door already opened
	
	LD A,(CurrentItem)
	CP 3				;key?
	RET NZ
	
	INC (HL)			;change status - open door
	CALL KillCurrentItem
	LD A,5
	CALL TypeMessage	
	RET
	
;-----		
ChangeFuse
	LD HL,FuseboxStatus
	LD A,(HL)
	CP 2
	RET Z				;status 2- fuse replaced, don't do it more
	OR A
	JR NZ,ChangeFuse1
	
;status 0 - open fusebox	
	LD A, (CurrentItem)
	CP 1				;screwdriver?
	RET NZ
	INC (HL)			;change status to 1
	CALL KillCurrentItem
	LD A,6
	CALL TypeMessage 
	RET
;status 1 - change fuse	
ChangeFuse1
	LD A,(CurrentItem)
	CP 15				;fuse?
	RET NZ
	INC (HL)			;change status to 2
	CALL KillCurrentItem
	LD A,7
	CALL TypeMessage
	RET	
	
;-----
UseComputer
	LD A,(FuseboxStatus)
	CP 2
	JR Z,UseComputer2	
	LD A,23
	CALL TypeMessage	;out of power
	RET
	
UseComputer2
	LD HL,DoorsStatus
	LD A,(HL)
	OR A
	RET NZ				;already activated
	
	LD A,(CurrentItem)
	CP 8				;diskette?
	RET NZ
	INC (HL)			;open doors
	CALL KillCurrentItem
	LD A,24
	CALL TypeMessage
	RET
		
;-----
MeetDog
	LD HL,DogStatus
	LD A,(HL)
	OR A
	RET NZ				;status 1 - dog friendly
	
	LD A,(CurrentItem)
	CP 12				;food
	JR NZ,MeetDog2
	
	INC (HL)			;change dog status to 1
	CALL KillCurrentItem
	LD A,11
	CALL TypeMessage
	RET
MeetDog2	
;dog unfriendly
	LD A,12
	CALL TypeMessage
	RET

	
;-----	
CutBranch
	LD HL,TreeStatus
	LD A,(HL)
	OR A
	RET NZ				;branch already cut
	
	LD A,(CurrentItem)
	CP 2				;saw?
	RET NZ
	
	INC (HL)			;change status - cut branch
	CALL KillCurrentItem
	LD A,13
	CALL TypeMessage	
	RET	
	
;-----	
OpenSteelgate
	LD HL,SteelgateStatus
	LD A,(HL)
	OR A
	RET NZ				;already opened
	
	LD A,(CurrentItem)
	CP 17				;dog?
	RET NZ
	
	INC (HL)			;open gate
	LD A,10
	CALL TypeMessage	
	RET	

;-----	
RemoveField
	LD HL,ElectroFieldStatus
	LD A,(HL)
	OR A
	RET NZ				;already removed
	
	LD A,(CurrentItem)
	CP 4				;pliers?
	RET NZ
	
	INC (HL)			;remove field
	CALL KillCurrentItem
	LD A,17
	CALL TypeMessage	
	RET	
	
;-----	
RemovePlant
	LD HL,PlantStatus
	LD A,(HL)
	OR A
	RET NZ				;already removed
	
	LD A,(CurrentItem)
	CP 13				;poison?
	RET NZ
	
	INC (HL)			;remove plant
	CALL KillCurrentItem
	LD A,20
	CALL TypeMessage	
	RET	
	
;-----		
MoveCart
	LD HL,CartStatus
	LD A,(HL)
	OR A
	RET NZ				;already removed
	
	LD A,(CurrentItem)
	CP 21				;lever?
	RET NZ
	
	INC (HL)			;move cart
	CALL KillCurrentItem
	LD A,15
	CALL TypeMessage	
	RET

;-----
C1GoDoor
	;change location
	LD A,14				;new position			
 	LD (JetmanX),A
 	LD A,2*16+2
	LD (CurrentRoomNr),A
 	CALL ChangeLocation_Action
	RET	
	
C2GoDoor
	;change location
 	LD A,178			;new position			
 	LD (JetmanX),A
 	LD A,2*16+1
	LD (CurrentRoomNr),A
 	CALL ChangeLocation_Action
	RET
		
;-----		
RemoveWallC2
	LD HL,C2WallStatus
	LD A,(HL)
	OR A
	RET NZ				;already removed
	
	LD A,(CurrentItem)
	CP 5				;pickaxe?
	RET NZ
	
	INC (HL)			;remove wall
	CALL KillCurrentItem
	LD A,14
	CALL TypeMessage	
	RET
	
;-----		
PumpWater
	LD HL,WaterStatus
	LD A,(HL)
	OR A
	RET NZ				;already pumped out
	
	LD A,(CurrentItem)
	CP 18				;pump?
	RET NZ
	INC (HL)			;pump water
	CALL KillCurrentItem
	LD A,27
	CALL TypeMessage	
	RET
	
;-----	
FillFuel
	LD HL,FuelStatus
	LD A,(HL)
	OR A
	RET NZ				;already filled
	
	LD A,(CurrentItem)
	CP 14
	RET NZ
	INC (HL)			;fill can with fuel
	LD A,16
	CALL TypeMessage	
	RET
	
;-----	
MakeBridge
	LD HL,BridgeStatus
	LD A,(HL)
	OR A
	RET NZ				;already created
	
	LD A,(CurrentItem)
	CP 19				;emitter?
	RET NZ
	INC (HL)			;create bridge
	CALL KillCurrentItem
	LD A,25
	CALL TypeMessage	
	RET
	
;-----
DestroyDoorF8
	LD HL,F8DoorStatus
	LD A,(HL)
	OR A
	JR NZ,GoDoorF8		;door already destroyed, go through door

	LD A,(CurrentItem)
	CP 11				;grenade?
	JR Z,DestroyDoorF8_2	
	LD A,21				;door jammed
	CALL TypeMessage
	RET
	
DestroyDoorF8_2	
	INC (HL)			;destroy door, change status
	CALL KillCurrentItem
	LD A,22
	CALL TypeMessage
	RET
	
GoDoorF8	
 	LD A,6*16+8			;go to G8
	LD (CurrentRoomNr),A
 	CALL ChangeLocation_Action
	RET	

;-----	
GoDoorG8
	LD HL,(5*16+8)*256+181					
	LD DE,128*256+168			
	JP GoDoor2
	
;-----
GoDoorG13
	LD A,(CurrentItem)
	CP 9				;torch
	JR Z,GoDoorG13_2
	LD A,(OtherItem)
	CP 9
	JR Z,GoDoorG13_2
;no torch in inventory
	LD A,19
	CALL TypeMessage
	RET

GoDoorG13_2
	LD HL,(7*16+13)*256+177					
	LD DE,128*256+144			
	JP GoDoor2
	
;-----
GoDoorH13
	LD HL,(6*16+13)*256+177					
	LD DE,128*256+144			
	JP GoDoor2

;-----	
OpenDoorD16
	LD HL,D16DoorStatus
	LD A,(HL)
	OR A
	RET NZ				;door already opened
	
	LD A,(CurrentItem)
	CP 20				;key 3?
	RET NZ
	INC (HL)			;change status - open door
	CALL KillCurrentItem
	LD A,5
	CALL TypeMessage	
	RET
	
;-----	
RemoveRocks
	LD HL,RocksStatus
	LD A,(HL)
	OR A
	RET NZ				;door already opened
	
	LD A,(CurrentItem)
	CP 7				;detonator?
	RET NZ
	LD A,(OtherItem)
	CP 6				;dynamite?
	RET NZ
	
	INC (HL)			;change status - remove rocks
	
	LD B,4				;destroying both items-clearing their data
	XOR A
	LD HL,FirstItem
RemoveRocks2
	LD (HL),A
	INC HL
	DJNZ RemoveRocks2
		
	LD A,26
	CALL TypeMessage	
	CALL DrawMenuItems
	RET
	
;-----
ActivateLift
	LD HL,LiftStatus
	LD A,(HL)
	OR A
	RET NZ
	
	LD A,(CurrentItem)
	CP 22
	RET NZ
	INC (HL)
	CALL KillCurrentItem
	LD A,18
	CALL TypeMessage
	RET
	
;-----
E15GoLift
	LD A,(LiftStatus)
	OR A
	RET Z
	
	LD A,80				;new position			
 	LD (JetmanY),A
	LD A,3*16+15
	LD (CurrentRoomNr),A
	CALL ChangeLocation_Action
	RET
	
;-----
D15GoLift
 	LD A,112				;new position			
 	LD (JetmanY),A
 	LD A,4*16+15
	LD (CurrentRoomNr),A
 	CALL ChangeLocation_Action
	RET
	
;-----
FlyAway
	LD A,(CurrentItem)
	CP 14					;fuel can?
	RET NZ
	LD A,(FuelStatus)		;filled with fuel?
	OR A
	RET Z

	LD A,(OtherItem)
	CP 17					;dog?
	JR NZ,FlyAway2	
	LD A,(Disks)
	CP 9					;nine disk collected
	JR NZ,FlyAway2
	
	CALL Outro				;end of game
	
FlyAway2	
	LD A,28
	CALL TypeMessage
	RET
	
	
;-------------------
;go doors
GoB7Door
	LD HL,(2*16+7)*256+173					
	LD DE,128*256+112			
	JR GoDoor

GoC6Door
	LD HL,(3*16+6)*256+175					
	LD DE,128*256+128
	JR GoDoor

GoC7Door
;parameters for succesful going through door
	LD HL,(1*16+7)*256+173		;H - new location
								;L - position for door opening animation
	LD DE,128*256+112			;DE- new jetman position
	
	JR GoDoor
	
GoD6Door
	LD HL,(2*16+6)*256+175					
	LD DE,128*256+128
	JR GoDoor2			;if we are here -> doors are already activated, no need to check flags
	

;----
GoDoor
	LD A,(FuseboxStatus)
	CP 2
	JR Z,GoDoor1	;fuse replaced so maybe door opened or access denied
	LD A,23
	CALL TypeMessage	;out of power
	RET
GoDoor1
	LD A,(DoorsStatus)
	OR A
	JR NZ,GoDoor2
	LD A,8
	CALL TypeMessage	;access denied
	RET	
GoDoor2
;go through door
	CALL OpenDoor		;animation
	RET
	
;------------
OpenDoor
;door opening animation
 PUSH HL				;store data about new location
 PUSH DE

 LD H,90				;position of door animation bottom attribute (L already loaded)
 

 LD C,7
OpenDoor2
 
 LD A,71				;attribute
 LD B,4
 LD E,L
OpenDoor3
 LD (HL),A
 INC L
 DJNZ OpenDoor3
 
 LD A,E					;go one attribute line up
 SUB 32
 LD L,A
 JR NC,OpenDoorSound
 DEC H					;change segment
 
OpenDoorSound			;sound and delay
 HALT
 LD B,180
OpenDoorSound1 
 XOR A
 OUT (254),A
 LD D,B
OpenDoorSound2 
 DEC D
 JR NZ,OpenDoorSound2
 LD A,16
 OUT (254),A
 DJNZ OpenDoorSound1
 
 DEC C
 JR NZ,OpenDoor2
 
;go to new location
 POP DE					;restore data about new location
 POP HL 
 LD (JetmanX),DE		;new jetman position
 LD A,H					;new location
 LD (CurrentRoomNr),A
 CALL ChangeLocation_Action
 RET
 

 
;------------
ChangeLocation_Action
	CALL FindRoom
	CALL DrawRoom
 	CALL ChangeRoom
 	RET
	

 
 
 
 
 
