Intro
	CALL ClearScreen
	
;---------------------------------------
;intro screen 1
IntroScreen1
	LD HL,16384
	LD DE,IntroText1
	CALL TypeText
	
	LD HL,22528
	LD BC,32*256+8
	CALL FadeIn
	CALL Wait2Seconds
	CALL ClearScreen
;--------
	LD HL,16384
	LD DE,IntroText2
	CALL TypeText
	LD HL,22528
	LD BC,32*256+4
	CALL FadeIn

	LD HL,16384+227
	LD BC,26*256+13
	CALL DrawBorder

	LD HL,18432+4
	LD DE,IntroTile1
	LD BC,2*256+2
	PUSH DE
	PUSH BC
	CALL TileBlock
	
	LD HL,18432+20
	POP BC
	POP DE
	CALL TileBlock
	
	LD HL,20480+4
	LD DE,IntroTile2
	LD BC,24*256+1
	CALL TileBlock
	
	
	
	LD HL,18432+12
	LD DE,IntroDoor1
	CALL DrawTile
	
	LD HL,18432+44
	LD DE,IntroDoor2
	LD BC,1*256+7
	PUSH DE
	PUSH BC
	CALL TileBlock
	
	LD HL,18432+51
	POP BC
	POP DE
	CALL TileBlock
	
;sliding door animation
	LD A,23							;width of one door side in pixels
DrawIntroDoor1
;prepare doors graphics
	PUSH AF
	CALL PrepareSlidingDoor
	
	HALT
	
	LD BC,1200
IntroInterruptDelay					;without this routine, the door animation flickers
	LD A,(HL)						;the routine consumes some time doing nothing until screen scanning reaches lower part of the screen
	DEC BC							;when it happens, drawing in middle part of the screen begins
	LD A,B
	OR C
	JR NZ,IntroInterruptDelay

;draw man	
	LD HL,18432+64+14
	LD DE,IntroJetman
	CALL DrawTile
	
;draw door over him
	LD B,56							;door height
	LD HL,18432+32+13			;top door line

DrawIntroDoor2	
	PUSH BC
	CALL DrawSlidingDoor
	CALL OnePixelLineDown
	POP BC
	DJNZ DrawIntroDoor2	
	
	CALL RocketSound
	LD B,8
IntroInterruptDelay2	
	HALT
	DJNZ IntroInterruptDelay2	
	
	POP AF
	DEC A
	JR NZ,DrawIntroDoor1	
	
	CALL Wait2Seconds
	CALL ClearScreen

;---------------------------------------
;intro screen 2
IntroScreen2	
	LD HL,16384+5
	LD BC,20*256+13
	CALL DrawBorder
	
	LD HL,16384+198
	LD DE,IntroTile3
	LD BC,18*256+1
	CALL TileBlock
	
	LD HL,16384+71
	LD DE,IntroSoldier1
	CALL DrawTile
	
	LD HL,16384+82
	LD DE,IntroSoldier2
	CALL DrawTile
	
	LD HL,16384+108
	LD DE,IntroCommander
	CALL DrawTile
	
	LD HL,16384+45
	LD DE,IntroEagle
	CALL DrawTile
	
	LD HL,18432+76
	LD DE,IntroHeadColors
	CALL DrawTile
	
	
	LD C,16
	LD DE,IntroHead
MoveIntroHead1
	LD B,12
MoveIntroHead2	
	HALT
	DJNZ MoveIntroHead2
	
	PUSH BC					;scrolling area size
	PUSH DE					;store head graphics addresss
	LD HL,18432+76
	LD BC,4*256+2
	CALL ScrollUp			;scroll graphics one line up
							
							;new graphics appear at the bottom line of scrolling area
	LD HL,20332				;address of lowest pixel line in scrolling area						
	POP DE					;restore head graphics addresss
	LD B,4					;line width
MoveIntroHead3
	LD A,(DE)
	LD (HL),A
	INC L					;next collumn
	INC DE					;next graphics data byte
	DJNZ MoveIntroHead3
	
	POP BC					;restore numver of scrolling cycles
	DEC C
	JR NZ,MoveIntroHead1

;------------
;screen	2 conversation
	LD IX,IntroConversationData
	LD B,10

IntroConversation
	PUSH BC
	LD HL,18656				;screen position
	LD E,(IX+0)				;read text data
	INC IX
	LD D,(IX+0)
	INC	IX
	
	CALL TypeText
	LD HL,23008
	LD BC,32*256+9
	CALL FadeOut
	POP BC
	DJNZ IntroConversation
	
	JR IntroScreen3
	
IntroConversationData	
	.WORD IntroText3
	.WORD IntroText4
	.WORD IntroText5
	.WORD IntroText6
	.WORD IntroText7
	.WORD IntroText8
	.WORD IntroText9
	.WORD IntroText10
	.WORD IntroText11
	.WORD IntroText12

	
;---------------------------------------
IntroScreen3

	CALL ClearScreen
	
	LD HL,16384
	LD DE,IntroText13
	CALL TypeText
	LD HL,22528
	LD BC,32*256+2
	CALL FadeIn
	
	LD HL,16384+229
	LD BC,20*256+10
	CALL DrawBorder
	
	LD BC,500
IntroShipAnimation	
	PUSH BC
	HALT
	
	LD BC,1000
IntroInterruptDelay3				;without this routine, the  animation flickers
	LD A,(HL)						;the routine consumes some time doing nothing until screen scanning reaches lower part of the screen
	DEC BC							;when it happens, drawing in middle part of the screen begins
	LD A,B
	OR C
	JR NZ,IntroInterruptDelay3
	
	
	CALL DrawIntroPixels
	
	LD HL,18432+73
	LD DE,IntroShip
	CALL DrawTile
	
	LD HL,18432+105					;engine fire colors
	LD DE,IntroShipColors1
	
	LD A,R
	AND 00000010B
	OR A
	JR Z,IntroShipAnimation2					
	LD DE,IntroShipColors2
	
IntroShipAnimation2					
	CALL DrawTile					
	
	CALL MoveIntroPixels
	POP BC
	DEC BC
	LD A,B
	OR C
	JR NZ, IntroShipAnimation
	
	LD HL,22528+64
	LD BC,32*256+3
	CALL FadeIn
	CALL Wait2Seconds

;---------------------------------------
IntroScreen4

	CALL ClearScreen	
	
	LD HL,16384
	LD BC,14*256+24
	CALL DrawBorder
	
	LD HL,20480+161
	LD DE,IntroGround1
	CALL DrawTile
		
	LD HL,20480+171
	LD DE,IntroGround2
	CALL DrawTile
	
	LD HL,20480+163
	LD DE,IntroTile4
	LD BC,1*256+2
	PUSH DE
	PUSH BC
 	CALL TileBlock
	
	LD HL,20480+170
	POP BC
	POP DE
	CALL TileBlock
	
	LD HL,16384+16
	LD DE,IntroText14
	CALL TypeText
	
	LD A,23	
	CALL PrepareSlidingDoor
	CALL DrawCover
	
	LD HL,22528+16
	LD BC,16*256+9
	CALL FadeIn
	CALL Wait2Seconds
	
;----------------	
;sliding cover animation
	LD A,23					;width of one cover side in pixels
DrawIntroCover1
;prepare cover graphics
	PUSH AF
	CALL PrepareSlidingDoor
	
	
	
	CALL DrawCover
	
	LD B,8
IntroInterruptDelay4
	HALT
	DJNZ IntroInterruptDelay4
	
	CALL RocketSound
	
	POP AF
	DEC A
	JR NZ,DrawIntroCover1	

;------
;move rocket

;emerge rocket from screen bottom

	LD C,80
	LD DE,IntroRocket
MoveIntroRocket1
	
	;HALT	

	PUSH BC					
	PUSH DE					;store rocket graphics addresss
	CALL RocketSound
	LD HL,18598			;scrolling area position
	LD BC,2*256+10			;scrolling area size
	CALL ScrollUp			;scroll graphics one line up
							
							;new graphics appear at the bottom line of scrolling area
	LD HL,20678+7*256			;address of lowest pixel line in scrolling area						
	POP DE					;restore rocket graphics addresss
	LD B,2					;line width
MoveIntroRocket3
	LD A,(DE)
	LD (HL),A
	INC L					;next collumn
	INC DE					;next graphics data byte
	DJNZ MoveIntroRocket3
	
	POP BC					;restore number of scrolling cycles
	DEC C
	JR NZ,MoveIntroRocket1

;move rocket up and hide it at screen top
	LD C,190
MoveIntroRocket4
	
	;HALT
	
	PUSH BC					
	CALL RocketSound
	LD HL,16422			;scrolling area position
	LD BC,2*256+22			;scrolling area size
	CALL ScrollUp			;scroll graphics one line up
	POP BC					;restore number of scrolling cycles
	DEC C
	JR NZ,MoveIntroRocket4

	JR IntroScreen5
;--------
DrawCover
;draw cover over background
	LD B,3					;door height
	LD HL,20480+164+3*256	;top door line
DrawCover2	
	PUSH BC
	CALL DrawSlidingDoor
	CALL OnePixelLineDown
	POP BC
	DJNZ DrawCover2
	RET


;---------------------------------------
IntroScreen5
	CALL Wait2Seconds
	CALL ClearScreen
	
	LD HL,16384+5
	LD BC,20*256+14
	CALL DrawBorder
	
	LD HL,16384+231
	LD DE,IntroJetman2
	CALL DrawTile
		
	LD HL,16384+80
	
	LD DE,IntroExplosion
	CALL DrawTile
	
	CALL ExplosionSound
	
	LD HL,18432+224
	LD DE,IntroText15
	CALL TypeText
	LD HL,23008
	LD BC,32*256+4
	CALL FadeIn
	LD HL,23008+160
	LD BC,32*256+3
	CALL FadeIn
	
				
	CALL Wait2Seconds
	CALL Wait2Seconds			
	
	JP StartMenu
	
	
	
;-----------------------------
PrepareSlidingDoor
;A:door width - number of pixels from each side	
	PUSH AF

	LD HL,SlidingDoorBuffer
	LD B,6
	LD D,255
	LD E,0	

;clear sliding door buffer	
PrepareSlidingDoor2
	LD (HL),D						;masks =255 (show all)
	INC HL
	LD (HL),E
	INC HL							;graphics =0 (no graphics)
	DJNZ PrepareSlidingDoor2		

;-------------	
;left door
	LD HL,SlidingDoorBuffer
PrepareSlidingDoorLeft1
	CP 8							;last incomplete byte of graphics?
	JR C,PrepareSlidingDoorLeft2

;fill 8 pixels
	INC HL							;mask byte isn't important, so skip it
	LD (HL),D						;write 255 to grapics byte
	INC HL							;next byte
	
	SUB 8							;decrease number of pixels
	JR PrepareSlidingDoorLeft1	
	
PrepareSlidingDoorLeft2
;last byte from left side
;A is from 0 to 7
	LD B,A
	INC B							; A=0 -> execute loop once
	LD DE,SlidingDoorData-4
PrepareSlidingDoorLeft3
	INC DE
	INC DE
	INC DE
	INC DE
	DJNZ PrepareSlidingDoorLeft3
;DE points to last left door byte mask and sprite
	LD A,(DE)						;mask
	LD (HL),A						;write it to door buffer
	INC HL
	INC DE	
	LD A,(DE)						;graphics
	LD (HL),A						;write it to door buffer
	INC HL
	INC DE	
	
	POP AF							;restore door width in A to be used with right door
	PUSH DE							;store last byte address data
;-------------	
;right door
	LD HL,SlidingDoorBuffer+11		;last byte of door buffer, now we are moving from right to left
	LD D,255
	LD E,0
	
PrepareSlidingDoorRight1
	CP 8							;last incomplete byte of graphics?
	JR C,PrepareSlidingDoorRight2

;fill 8 pixels
	LD (HL),D						;write 255 to graphics byte
	DEC HL							;mask byte isn't important, so skip it
	DEC HL							;next graphics byte
	
	SUB 8							;decrease number of pixels
	JR PrepareSlidingDoorRight1

PrepareSlidingDoorRight2			;DE points to last left door byte mask and sprite
	POP DE							
	
	DEC HL							;go to mask byte in buffer
	LD A,(DE)						;mask
	LD (HL),A						;write it to door buffer
	INC HL		
	INC DE	
	
	LD A,(DE)						;graphics
	LD (HL),A						;write it to door buffer
	RET
	
	
;------------------------------
DrawSlidingDoor
;draw one pixel line of sliding door
;HL:line screen address
	PUSH HL	
	LD DE,SlidingDoorBuffer
	LD B,6
DrawSlidingDoor2
	LD A,(DE)						;mask
	AND (HL)
	LD (HL),A
	INC DE							;next data

	LD A,(DE)						;graphics
	OR (HL)
	LD (HL),A
	INC DE							;next data
	INC L							;next byte
	DJNZ DrawSlidingDoor2
	POP HL
	RET
;------------------------------
DrawBorder
;draw an empty box with a border (for text or picture to be placed later)
	;HL: position of left upper box corner
	;BC: size,B=width,C=height
	

;clear box area	
	PUSH BC
	PUSH HL
	LD DE,EmptySpace		
	CALL TileBlock
	POP HL
	POP BC

;-------
;draw top edge	
	PUSH BC
	PUSH HL
	LD DE,BorderTL					;left top corner
	CALL DrawTile
	POP HL
	POP BC
	
	INC L							;horizontal line width= border width - 2 (for corners)
	DEC B
	DEC B
;top line
	PUSH BC							;store size
	LD DE,BorderT	
DrawBorder2
	PUSH HL
	PUSH DE
	PUSH BC
	CALL DrawTile
	POP BC
	POP DE
	POP HL
	INC L
	DJNZ DrawBorder2
	
	LD DE,BorderTR
	PUSH HL
	CALL DrawTile					;right top corner
	POP HL
	POP BC							;restore size

;-------										
;draw left and right edge
	PUSH BC							;store size
	DEC C
	DEC C
	
	
DrawBorder3
	CALL OneCharacterLineDown	

	LD DE,BorderR
	PUSH HL
	PUSH BC							;draw right edge
	CALL DrawTile	
	POP BC
	POP HL
	
	PUSH HL							;store right edge
	
	LD A,L							;go to left edge
	SUB B
	DEC A
	LD L,A							
	
	LD DE,BorderL
	PUSH BC							;draw left edge
	CALL DrawTile	
	POP BC
	
	POP HL							;restore right edge
	
	DEC C							;do it C times
	JR NZ,DrawBorder3

	POP BC							;restore size
	
;-------										
;draw bottom edge
	CALL OneCharacterLineDown
	
	LD DE,BorderBR
	PUSH HL
	PUSH BC							;bottom right corner
	CALL DrawTile	
	POP BC
	POP HL

	DEC L							
;bottom line
	LD DE,BorderB	
DrawBorder4
	PUSH HL
	PUSH DE
	PUSH BC
	CALL DrawTile
	POP BC
	POP DE
	POP HL
	DEC L
	DJNZ DrawBorder4
	
	LD DE,BorderBL					;bottom left corner
	CALL DrawTile	
	
	RET		
	
;-----------
BorderTL
	.BYTE 1,1
	.BYTE	  0,  0,  0,  7, 15, 28, 25, 26
	.BYTE 68

BorderT
	.BYTE 1,1
	.BYTE	  0,  0,  0,255,255,  0,255,  0
	.BYTE 68
	
BorderTR
	.BYTE 1,1	
	.BYTE	  0,  0,  0,224,240, 56,152, 88
	.BYTE 68
	
BorderL
	.BYTE 1,1	
	.BYTE	 26, 26, 26, 26, 26, 26, 26, 26
	.BYTE 68
	
BorderR
	.BYTE 1,1	
	.BYTE	 88, 88, 88, 88, 88, 88, 88, 88
	.BYTE 68
	
BorderBL
	.BYTE 1,1	
	.BYTE	 26, 25, 28, 15,  7,  0,  0,  0
	.BYTE 68
	
BorderB
	.BYTE 1,1	
	.BYTE	  0,255,  0,255,255,  0,  0,  0
	.BYTE 68

BorderBR
	.BYTE 1,1	
	.BYTE	 88,152, 56,240,224,  0,  0,  0
	.BYTE 68
	
;--------------------------	
ScrollUp
;move the graphics in descried collumns one pixel up
;graphics which reach top of scrolling area dissapear
;hl: screen address, b:width in bytes, c:height in character lines
	
	LD D,H
	LD E,L			;DE=HL
	
	INC D			;de points to ne pixel line lower than HL

ScrollUp2		
	PUSH BC			;store scrolling area
	
;do one character line	
	LD C,7			;repeat 7 times
	
ScrollUp3	
	PUSH BC
	LD C,L			;store first byte in the line screen position
ScrollUp4
	LD A,(DE)		;read lower byte	
	LD (HL),A		;and write it one line higher
	INC L
	INC E			;next byte in a line
	DJNZ ScrollUp4	;do one pixel line
	
	LD L,C			;restore  position of first byte in the line
	LD E,C
	
	INC H			;go one line down
	INC D
	
	POP BC			;restore number of repeats
	DEC C
	JR NZ,ScrollUp3
	

	
	LD A,E			;the last pixel line in character line is different
	ADD A,32		;because whe read the line below it from next character
	LD E,A			;go one character line down
	
	LD C,E			;store first byte in the line screen position
	
	JR C,ScrollUp5	;next segment?
	LD A,D
	SUB 8
	LD D,A

ScrollUp5			;copy last pixel line in character line
	LD A,(DE)		
	LD (HL),A		
	INC L
	INC E			
	DJNZ ScrollUp5
	
	LD E,C			;restore first byte in the new character line screen position	
	LD L,E			;HL becomes DE
	LD H,D
	INC D			;D goes one line lower
	
	POP BC			;restore scrolling area
	DEC C			;number of character lines left to do
	JR NZ,ScrollUp2
	
	RET				
;--------------------------
MoveIntroPixels	
;moves every pixel by number of pixels	stored in next byte
	LD HL,IntroPixelsData

	LD B,64							;number of lines
MoveIntroPixels2
	LD C,(HL)						;read speed
	INC HL
	LD A,(HL)						;read pixel position
	SUB C							;move pixel left
	JR NC,MoveIntroPixels3			;carry means that position<0
	
	AND 00000111B					;carry happened, pixel appears from the right side of scrolling area
									;A=0-7
	ADD A,17*8						;area is 18 characters wide
MoveIntroPixels3
	LD (HL),A						;store new position
	INC HL							;next byte
	DJNZ MoveIntroPixels2
	RET
	

;--------------------------
DrawIntroPixels
;draw pixels which represent moving stardust during flying ship animation
;pixels data are stored in a table, there is one pixel for each pixel line
;so we store this pixel position and its speed
	
	LD HL,18432+6					;left upper corner of pixels animation area
	LD DE,IntroPixelsData+1
	
	
	LD C,8							;number of character lines
	LD B,8	
DrawIntroPixels1
	PUSH BC
	PUSH HL
DrawIntroPixels2
	LD C,L							;store L
	LD A,(DE)						;read pixel offset
	
	PUSH BC
	CALL DrawSinglePixel			;draw pixel
	POP BC
	
	INC DE
	INC DE							;go to next pixel data (skip speed byte)
	LD L,C							;restore L
	INC H							;go one line down
	DJNZ DrawIntroPixels2
	
	POP HL
	LD A,L
	ADD A,32
	LD L,A							;go to next character line
	
	POP BC							;restore both B and C
	DEC C
	JR NZ,DrawIntroPixels1
	RET
;------------	
DrawSinglePixel
;HL: pixel line address
;A:  pixel position (offset from left edge)	
	
	LD B,0
	LD (HL),B						;clear first byte in the line (it isn't normally cleared)
				
DrawSinglePixel2
	INC L							;next byte
	SUB 8
	JR NC,DrawSinglePixel2			;find byte containing our pixel
	
	ADD A,8							;loop executes once too much, so correct the values
	DEC L								
	
;A contains rotation now (0-7)
	INC A							;A=1-8
	LD B,A
	XOR A							;A=0
	SCF								;put 1 (lit pixel) into carry
DrawSinglePixel3
	RRA								;move this 1 right	
	DJNZ DrawSinglePixel3
	
	LD (HL),A						;draw pixel
	INC L
	LD A,L
	AND 00011111B					;extract collumn
	CP 24							;most right collumn?
	RET Z							;if so, don't clear next byte
	
	XOR A
	LD (HL),A						;clear next byte
	RET

	RET	
;--------------
IntroPixelsData
;first byte - pixel speed, second byte - pixel offset
;128 bytes (64 pixel lines * 2 bytes per line

	.BYTE 1, 113, 1, 36 , 4, 43 , 1, 143 ,1, 35, 2, 37, 3, 8,  1, 84
	.BYTE 2, 21 , 1, 135, 1, 116, 3, 22  ,1, 2,  4, 80, 3, 115,3, 11
	.BYTE 1, 50 , 3, 111, 1, 2  , 1, 89  ,3, 99, 1, 5,  2, 72, 2, 133
	.BYTE 3, 24 , 1, 26 , 2, 76 , 1, 70  ,1, 48, 1, 127,4, 66, 1, 15
	.BYTE 1, 107, 1, 81 , 1, 28 , 4, 15  ,4, 142,3, 85, 1, 120,1, 17
	.BYTE 4, 139, 1, 60 , 1, 140, 1, 9   ,2, 10, 2, 24, 1, 93, 4, 128
	.BYTE 1, 102 ,4, 17 , 1, 50 , 2, 124 ,1, 78, 1, 69, 2, 0,  1, 138
	.BYTE 1, 125, 3, 99 , 1, 57 , 1, 142 ,2, 109,1, 31, 4, 86, 2, 29

;--------------------------
Wait2Seconds
	PUSH BC
	LD B,100		
Wait2Seconds2
	HALT
	DJNZ Wait2Seconds2
	POP BC
	RET
;--------------------------
FadeIn
	LD A,7
	LD (FadeSelfModify1+1),A	;CP 7	
	LD A,60						;INC A
	LD (FadeSelfModify2),A

	CALL Fade
	RET

;------------	
FadeOut
	CALL WaitForPressingFire

FadeOut2
	XOR A
	LD (FadeSelfModify1+1),A	;CP 0	
	LD A,61						;DEC A
	LD (FadeSelfModify2),A
	
	CALL Fade
	RET


;------------
Fade

;this subroutine uses self modyfing code
;it can either fade in color to white 7 or fade out to black 0
;here it is written as fade in

;fade  colors in a defined rectangle to black
;HL - left upper corner, BC - rectangle size
	LD D,50
Fade0
	HALT
	DEC D
	JR NZ,Fade0
	

Fade1	
	PUSH HL
	PUSH BC
	
	LD D,0					;are there any square left to fade in? 0-no, 1-yes
	
	
;line of squares
Fade2
	
	LD A, (HL) 				;get attribute
	AND 00000111B			;extract ink
FadeSelfModify1	
	CP 7					;do we still need to fade ?
	JR Z, Fade3			;no need
	
;do fade in
FadeSelfModify2	
	INC A					;change color (self modifying code: INC A - Fade in, DEC A - Fade out)
	LD D,1					;mark that FadeIn was done
	LD E,A
	LD A,(HL)
	AND 11111000B
	OR E					;merge ink with rest of attribute
	LD (HL),A
	
Fade3
	INC HL					;go to next square
	DJNZ Fade2
	
;go to new line
	LD E,C
	POP BC
	PUSH BC
	LD C,E 					;restore B while keeping C
	
	LD A,L
	SUB B					;go to the beginning of line
		
	ADD A,32				;go to beginning of new line
	LD L,A
	JR NC, Fade4			;not going to next screen segment
	
	LD A,H					;going to next screen segment
	ADD A,8
	LD A,H

Fade4
	DEC C
	JR NZ, Fade2
		
	
	LD E,6					;delay
Fade5
	HALT
	DEC E
	JR NZ,Fade5
	
	POP BC
	POP HL
	
	LD A,D
	OR A					;were any FadeIn done in this round?
	JR NZ,Fade1 			;if so, repeat
	
	RET

;---------------SOUNDS------------
MenuSound
	LD DE,28000
MenuSound2	
	LD H,6
	LD A,40
	
MenuSound3	
	LD C,254
	XOR 16
	OUT (C),A
	LD B,E
MenuSound4	
	DJNZ MenuSound4
	DEC H
	JR NZ,MenuSound3
	INC E
	INC E
	INC E
		
	DEC D
	JR NZ,MenuSound2
	RET			

;------------------------	
ExplosionSound
	LD L,6
	LD E,0
	LD D,128
Explosion1	
	PUSH DE
Explosion2	
	LD B,E
Explosion3
	DJNZ Explosion3
	LD A,(BC)
	AND 248
	OR L
	AND 11111000B
	OUT (254),A
	INC C
	DEC D
	JR NZ,Explosion2
	
	POP DE
	INC E
	DEC D
	JR NZ,Explosion1		
	RET
	
;------------------------
RocketSound
	LD B,5
	LD C,8
RocketSound2	
	DEC H
	JR NZ,RocketSound3
	
	XOR A
	OUT (C),A
	LD H,238
RocketSound3
	DEC L
	JR NZ, RocketSound2
	
	LD A,16
	OUT (C),A
	LD L,254
	DJNZ RocketSound2
	RET

;---------------------------------
;Intro graphics
IntroTile1
	.BYTE 4,4
	.BYTE	254,192,160,144,136,132,  2,129
	.BYTE	237,  0,  0,  0,  0,  0,  0,  0
	.BYTE	 68,  0,  0,  0,  0,  0,  0,  0
	.BYTE	254,252,248,240,224,192,128,  0
	.BYTE	128,128,  0,128,128,  0,128,  0
	.BYTE	128, 64, 32, 16,  8,  4,  2,  1
	.BYTE	254,252,248,240,224,192,128,  0
	.BYTE	255,255,255,255,255,255,255,255
	.BYTE	128,  0,128,  0,  0,  0,128,  0
	.BYTE	254,252,248,240,224,192,128,  0
	.BYTE	255,127, 63, 31, 15,  7,  3,  1
	.BYTE	255,255,255,255,255,255,255,255
	.BYTE	254,252,248,240,224,192,128,  0
	.BYTE	170,  0,  0,  0,  0,  0,  0, 69
	.BYTE	170,  0,  0,  0,  0,  0,  0, 91
	.BYTE	255,127, 63, 31, 15,  7,  3,191
	.BYTE	 47, 47, 47, 13, 47,111, 77,  1
	.BYTE	 47, 69, 65,  1,  5,  1,  1,  1

IntroTile2
	.BYTE 1,3
	.BYTE	  0,255,255,255,255,255,255,  0
	.BYTE	255,255,  0,255,  0,255,  0,  0
	.BYTE	255,  0,  0,255,  0,  0,  0,255
	.BYTE	  2,  2,  2

IntroDoor1
	.BYTE 8,1
	.BYTE	127,127,127,127,127,127,127,126 
	.BYTE	255,255,254,254,254,255,255,  0
	.BYTE	255,  0,255,171, 85,  0,255,  0
	.BYTE	255,  0,246,236,246,  0,255,  0
	.BYTE	255,  0,111, 55,111,  0,255,  0
	.BYTE	255,  0,255,213,170,  0,255,  0
	.BYTE	255,255,127,127,127,255,255,  0
	.BYTE	254,254,254,254,254,254,254,126
	.BYTE	 71, 71, 71, 71, 71, 71, 71, 71
	
IntroDoor2	
	.BYTE 1,1
	.BYTE 126,126,126,126,126,126,126,126
	.BYTE 71
	
IntroJetman
	.BYTE 4,6
	.BYTE 16
	.BYTE	  0,  0,  0,  0,  3,  5,  8,  8
	.BYTE	  0,  0,  0,  0,224, 80,168, 24
	.BYTE 16
	.BYTE 16
	.BYTE	 11,  0,  3, 11, 17, 18, 17, 44
	.BYTE	232,128,224,104,196, 36,196, 26
	.BYTE 16
	.BYTE	  1,  7, 31, 63,120,247,240,248
	.BYTE	179,220,223,239,  7,240, 11,229
	.BYTE	231, 31,254,254,124,130,254,253
	.BYTE	  0, 96,240,216,232,220,244,126
	.BYTE	120, 56, 22, 78,108, 96,112, 56
	.BYTE	116, 50, 26, 10,  2,  2,  4,  5
	.BYTE	250,252,234,212,  0,252,252,252
	.BYTE	112, 46, 30, 28, 60, 60, 56, 88
	.BYTE	 60, 30, 15,  0,  0,  0,  0,  0
	.BYTE	  9, 19,103, 14, 62, 62,126,124
	.BYTE	254,126, 62, 63, 31, 31, 31, 15
	.BYTE	192,224, 96,  0,  0,  0,128,128
	.BYTE 16
	.BYTE	124,124,  0, 60, 60,124,252,  0
	.BYTE	 15, 15,  0,  7,  7,  7,  7,  0
	.BYTE	128,128,  0,128,192,224,240,  0
	.BYTE	  0, 71, 71,  0,  0, 71, 71,  0
	.BYTE	 71, 71, 71, 71, 71, 71, 71, 71
	.BYTE	 71, 71, 71, 71,  0, 71, 71, 71
	
	
IntroCommander
	.BYTE 5,6
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0,  0,  0,  0, 62, 79, 49
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0,  0,  0,  0,  0,  7, 15
	.BYTE	 62,  8, 54, 62, 34, 28, 99, 62
	.BYTE	  0,  0,  0,  0,  0,  0,112,120
	.BYTE 16
	.BYTE 16
	.BYTE	  0, 31, 63, 63, 61, 61, 28, 30
	.BYTE	129,251,235, 58,235,251,235,251
	.BYTE	128,248,252,116,248,180,188,120
	.BYTE 16
	.BYTE	241,163, 70, 12, 26, 52,106,245
	.BYTE	206, 15,  7,  7,  1,  0,  0,  0
	.BYTE	  0,  0,  0, 98,118,118, 52,  0
	.BYTE	232,208,160,192,128,  0,  0,  0
	.BYTE	254, 94, 46, 28, 56, 48,100,204
	.BYTE	255,  0,127, 67, 70, 77, 90,117
	.BYTE	255,  0,255, 95,190,125,219,182
	.BYTE	255,  0,255,255,255,127,191,222
	.BYTE	255,  0,254,254,250,182,106,214
	.BYTE	156, 60,252,252,252,252,252,252
	.BYTE	107, 86,109, 95,127,127,  0,  0
	.BYTE	100,242,249,252,254,255,  0,  0
	.BYTE	 77,155, 62,125,250,255,  0,  0
	.BYTE	174, 90,178, 98,194,254,  0,  0
	.BYTE	248,248,240,224,192,128,  0,  0
	.BYTE	  0,  0,  5,  0,  0,  0,  5,  5
	.BYTE	  5,  0,  0, 69, 69, 69,  0,  1
	.BYTE	 69,  5,  69,  1, 65, 65, 65, 65
	.BYTE	  1, 65, 65, 65, 65,  1
	
IntroSoldier1	
	.BYTE 4,6
	.BYTE 16
	.BYTE	  0,  7, 15, 15,  4, 11, 15,  9
	.BYTE	  0,  0,128,128,128,128,128,128
	.BYTE 16
	.BYTE	  0,  0,  1,  6, 15, 31, 63, 63
	.BYTE	 15, 16,239,240,127,127, 95, 47
	.BYTE	  0, 64,160,112,248,248,250,243
	.BYTE 16
	.BYTE	127,126, 12, 64, 84,106,117, 62
	.BYTE	 21,139,192,159, 32, 64, 64,185
	.BYTE	171, 87,  0,255,  0, 12, 30,222
	.BYTE	128,128,  4,254,  2, 62,192,  0
	.BYTE	 63, 31,  7,  1,  0,  0,  0,  1
	.BYTE	125,125,121,151,  0,255,255,253
	.BYTE	 28, 96, 96,  0,224,240,240,248
	.BYTE 16
	.BYTE	253,169, 81,  3,  3,  3,  3,  7
	.BYTE	252,248,248,240,240,224,224,224
	.BYTE	248,252,124,126, 62, 62, 63, 31
	.BYTE 16
	.BYTE	  7,  7,  7,  0,  7, 15, 31, 30
	.BYTE	192,192,192,  0,128,128,  0,  0
	.BYTE	 31, 31,  0, 15, 15, 15,  7,  0
	.BYTE	  0,  0,  0,  0,128,192,224,  0
	.BYTE	  0,  1,  1,  0,  1,  1,  1,  0
	.BYTE	  1,  1,  1,  1,  1,  1,  1,  0
	.BYTE	  1,  1,  1,  1,  1,  1,  1,  1
	
IntroSoldier2
	.BYTE 4,6
	.BYTE 16
	.BYTE 16
	.BYTE	 84,170,124,146,238,254, 68,124
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0,  1,  7, 15, 47,111,231
	.BYTE	130,124,131,255,255,255,207, 35
	.BYTE	  0,  0,128,192,224,200,220,158
	.BYTE	  1,  1,  3,  3,  4,  6, 15, 15
	.BYTE	240,242,245,243,227,  3,128,  3
	.BYTE	 88,181,122,255,255,255,  0,255
	.BYTE	 62, 63,191, 63,191,158, 46, 48
	.BYTE	  0, 47,112, 64,127, 14,  0,  0
	.BYTE	 60,192,  0,255,  0,  6,  6, 14
	.BYTE	  1,  0, 27,189,189,157,195, 28
	.BYTE	124,252,248,248,240,224,128,  0
	.BYTE	16
	.BYTE	207,159, 31, 63, 62, 62,126,124
	.BYTE	159,143, 15,  7,  7,  3,  3,  3
	.BYTE	223,202,197,224,224,224,224,240
	.BYTE	  0,  0,  0,  0,  0,  1,  3,  0
	.BYTE	124,124,  0,120,248,248,240,  0
	.BYTE	  1,  1,  1,  0,  0,  0,  0,  0
	.BYTE	240,240,240,  0,240,248,124, 60
	.BYTE	  0,  0,  1,  0,  0,  1,  1,  1
	.BYTE	  1,  1,  1,  1,  1,  1,  1,  1
	.BYTE	 1,  1,  1,  1,  1,  1,  1,  1
	
IntroEagle
	.BYTE 3,2
	.BYTE	127, 64, 66, 68, 76, 78, 74, 77
	.BYTE	255,  0, 14, 27, 30, 28, 28, 65
	.BYTE	255,  1, 33, 17, 25, 57, 41, 89
	.BYTE	 74, 71, 65, 64, 64, 64, 64,127
	.BYTE	148, 42,148, 42,  0, 20,  0,255
	.BYTE	169,113,193,  1,  1,  1,  1,255
	.BYTE	 70, 70,  6, 70,  6,  6
		
IntroTile3
	.BYTE 1,1
	.BYTE 255,170,85,0,0,0,0,0
	.BYTE 65
	
IntroShip
	.BYTE 9,4
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0, 15, 21,  2, 17, 10,  0
	.BYTE	  0,  0,128,192,224,112,184,  0
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0,  0,  0, 42,  5,  0,  0
	.BYTE	  0,  1, 10, 84,170, 84,170,  0
	.BYTE	 62, 64,157,171,144,135, 71, 15
	.BYTE	127,255,255,255,  0,255,255,255
	.BYTE	255,255,255,255,  0,255,255,255
	.BYTE	255,255,255,255,  0,255,255,255
	.BYTE	240,200,132,  2,  2,  5,139,215
	.BYTE	  0,  0,  0,  0,240,252,255,255
	.BYTE	  0,  0,  0,  1, 42,  1,  0,  0
	.BYTE	  0,  1, 10, 84,170, 84, 10,  1
	.BYTE	 63, 64,159,190,149,138, 64, 63
	.BYTE	232,  3,231,143, 68,143,  0,239
	.BYTE	  0,255,255,255, 64,255,  0,255
	.BYTE	  0,227,203,147, 40,147, 36,128
	.BYTE	  0,255,255,255,  0,255,  0,  0
	.BYTE	 15,255,255,128, 63,192,  0,  0
	.BYTE	254,248,196, 56,192,  0,  0,  0
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	 14, 24, 49, 34, 69, 74, 87, 63
	.BYTE	 95,190,124,184,112,224,192,  0
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0,  0,  0, 71, 71,  0,  0
	.BYTE	  0,  0, 71, 71, 71, 71, 71, 71
	.BYTE	 71, 71, 71, 71, 71, 71, 71, 71
	.BYTE	 71, 71, 71,  0,  0,  0, 71, 71
	.BYTE	  0,  0,  0,  0
	
IntroShipColors1
	.BYTE 3,2
	.BYTE 16,16,16,16,16,16
	.BYTE 0,66,66,66,66,0
	
IntroShipColors2
	.BYTE 3,2
	.BYTE 16,16,16,16,16,16
	.BYTE 0,70,70,70,70,0		
	
IntroHead
	.BYTE	  0, 31,240,  0,  0,127,254,  0
	.BYTE	  1,255,255,128,  7,255,255,192
	.BYTE	 15,255,245, 96, 15,255,223,240
	.BYTE	 31,253,122,168, 63,247,213, 92
	.BYTE	 63,222,170,134,127,245, 84,  2
	.BYTE	127,106,168,  2,255,213, 64,  1
	.BYTE	253,170,128,  1,247, 84,  0,  1
	.BYTE	250,168,  0,  1,213, 64,  0,  1
	
IntroHeadColors
	.BYTE 4,2			;a tile used only to give sone color to screen area
	.BYTE 16,16,16,16
	.BYTE 16,16,16,16
	.BYTE 69,69,69,5
	.BYTE 69,69,69,5
	
IntroGround1
	.BYTE 2,2
	.BYTE	255,183,110,223,255,238,221,187
	.BYTE	254,125,246,237,222,253,246,237
	.BYTE	247,254,223,187,247,238,221,251
	.BYTE	 94,253,254,181,110,221,246,253
	.BYTE	  6,  6,  6,  6

IntroGround2
	.BYTE 2,2
	.BYTE	123,183,111,187,118,191,127,182
	.BYTE	255,221,187,119,239,254,253,239
	.BYTE	109,187,127,191,118,173,123,191
	.BYTE	223,254,253,107,222,189,251,119
	.BYTE	  6,  6,  6,  6

IntroTile4
	.BYTE 1,1	
	.BYTE	 74, 82, 74, 82, 74, 82, 74, 82
	.BYTE	 71

IntroRocket
	.BYTE	  1,  0,  1,  0,  1,  0,  1,128
	.BYTE	  3,128,  3,192,  7,192,  7,224
	.BYTE	 15, 80,  6,160,  3, 64,  0,  0
	.BYTE	  8, 16, 12, 16, 15, 80, 15,144
	.BYTE	 15, 80, 15,144, 15, 80, 15,144
	.BYTE	  7, 64,  3,128,  0,  0,  8, 16
	.BYTE	 12, 16, 15,144, 15, 80, 15,144
	.BYTE	 15, 80, 15,144, 15, 80, 15,144
	.BYTE	 15, 80, 15,144, 15, 80, 15,144
	.BYTE	 15, 80, 15,144,  7, 64,  3,128
	.BYTE	  0,  0,  8,  0, 44, 20, 47,212
	.BYTE	 47,148, 47, 84, 47,148,111, 86
	.BYTE	111,150,111, 86,111,150,111, 86
	.BYTE	111,150,239, 87,239,151,239, 87
	.BYTE	239,151,231, 71,227,135,224,  7
	.BYTE	232, 23,  4, 32,  3,192, 16, 16
	.BYTE	 20, 80, 18,144,  9, 80, 10,144
	.BYTE	  9, 80, 10,144,  9, 32, 10,160
	.BYTE	  9, 32, 10,160,  9, 32,  4, 64
	.BYTE	  5, 64,  2,128,  1,  0,  1,  0
	

	
IntroJetman2
	.BYTE 6,5	
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  1,  2,  4,  9, 11, 18, 20
	.BYTE	112,140,  2,241,128,  0,  0,  0
	.BYTE	  0,  0,  0,  0,128,128,128,192
	.BYTE 16
	.BYTE	  0,  0,  1,  7, 15, 39,119,118
	.BYTE	  0, 31,255,255,255,255,252, 25
	.BYTE	 20,144,212,232,236,246,243,249
	.BYTE	  0,  1,  1,  3,  4, 11, 58,253
	.BYTE	192,192,192,128,132, 24, 96,128
	.BYTE 16
	.BYTE	112, 32,  0,  0,  1,  6, 31,127
	.BYTE	 51,118,115,185,220,238, 71,147
	.BYTE	126,255,223,183,231, 79, 31,255
	.BYTE	114,  4,  8,144,160,128,128,  0
	.BYTE 16
	.BYTE	  0, 17, 27, 29, 14,  7,  7,  2
	.BYTE	255,255,254,248,224, 65,  3,  3
	.BYTE	197,238,119,122,252,248,240,224
	.BYTE	235,217, 25, 31, 62, 62, 60,124
	.BYTE 16
	.BYTE 16
	.BYTE 16
	.BYTE	  7, 15, 55,123, 57, 28, 14,  6
	.BYTE	224,192,192,128,  0,  0,  0,  0
	.BYTE	120, 16,192,224, 96,  0,  0,  0
	.BYTE 16
	.BYTE 16
	.BYTE	  0,  0,  0, 71, 71, 71,  0, 71
	.BYTE	 71, 71, 71, 71,  0, 71, 71, 71
	.BYTE	 71,  0, 71, 71, 71, 71,  0,  0
	.BYTE	  0, 71, 71, 71,  0,  0

IntroExplosion
	.BYTE 6,6
	.BYTE 16
	.BYTE	  0,  0,  0,  1, 18,  5, 10, 21
	.BYTE	  8, 16,170, 85,171,127,255,255
	.BYTE	  0,160, 84,170, 85,234,253,254
	.BYTE	  0,  0,  0,  0, 32,128, 64,160
	.BYTE 16
	.BYTE	  0,  0,  0,  1,  0,  5,  2,  5
	.BYTE	 43, 87,175, 95,191,127,255,255
	.BYTE	  0,  0,  4, 42, 85, 42, 95,191
	.BYTE	  0,  0, 64,160, 80,168,244,250
	.BYTE	 82,168,212,234,245,250,253,254
	.BYTE	  0,  0,  0,  0,  0,128,  0,160
	.BYTE	 42,  5, 11, 21, 43, 23, 43, 23
	.BYTE	  1, 10,  5,  3,  7, 11, 23, 11
	.BYTE	  2,  5, 11, 23, 47, 31, 47, 95
	.BYTE	160,240,232,244,250,252,254,253
	.BYTE	128, 64,128,192,168,208,224,208
	.BYTE	 64,160, 84,160,208,168,212,232
	.BYTE	 15, 11, 87, 43, 23, 11, 21, 10
	.BYTE	 23, 11,  7, 11,  5, 10,  1,  2
	.BYTE	 47, 23, 47, 23, 43, 21, 10,  5
	.BYTE	254,253,254,252,250,244,170, 80
	.BYTE	232,208,232,208,224,208,128, 64
	.BYTE	212,232,240,212,232,212,232,208
	.BYTE	  5,  2,  1,  0,  4,  0,  0,  0
	.BYTE	255,255,127,191, 95,171, 85, 43
	.BYTE	127,191, 95, 43, 21, 34,  5,  2
	.BYTE	253,250,244,248,244,168, 64,128
	.BYTE	255,255,255,255,254,253,250,213
	.BYTE	168, 80,160, 64,128,  0,  0,  0
	.BYTE 16
	.BYTE	 21, 42,  5, 18,  1,  0,  0,  0
	.BYTE	255,255,127,171, 85,170, 16,  1
	.BYTE	254,253,234, 85,170, 84,160,  0
	.BYTE	170, 64,144,  0,  0,  0,  0,  0
	.BYTE 16
	.BYTE	  0, 66, 66, 66, 66,  0, 66, 66
	.BYTE	 86, 86, 66, 66, 66, 86,119,119
	.BYTE	 86, 66, 66, 86,119,119, 86, 66
	.BYTE	 66, 66, 86, 86, 66, 66,  0, 66
	.BYTE	 66, 66, 66,  0
	
	
	
	
;------------------	
SlidingDoorBuffer
	.BYTE 0,0,0,0,0,0,0,0,0,0,0,0	;6 bytes for graphics and 6 for mask
									;bytes are mixed: mask,byte,mask, byte...	
	
SlidingDoorData
						;0 pixels
	.BYTE 01111111B		;left door edge mask					
	.BYTE 00000000B		;left door edge graphics
	.BYTE 11111110B		;left door edge mask
	.BYTE 00000000B		;right door edge graphics

	
	.BYTE 10111111B						
	.BYTE 10000000B		;1 pixel
	.BYTE 11111101B		
	.BYTE 00000001B		
		
	.BYTE 11011111B	
	.BYTE 11000000B		;2 pixels
	.BYTE 11111011B		
	.BYTE 00000011B		
	
	.BYTE 11101111B	
	.BYTE 11100000B		;3 pixels
	.BYTE 11110111B	
	.BYTE 00000111B		
		
	.BYTE 11110111B	
	.BYTE 11110000B		;4 pixels
	.BYTE 11101111B	
	.BYTE 00001111B		
		
	.BYTE 11111011B	
	.BYTE 11111000B		;5 pixels
	.BYTE 11011111B		
	.BYTE 00011111B		
	
	.BYTE 11111101B	
	.BYTE 11111100B		;6 pixels
	.BYTE 10111111B		
	.BYTE 00111111B		
	
	.BYTE 11111110B	
	.BYTE 11111110B		;7 pixels
	.BYTE 01111111B	
	.BYTE 01111111B		

;----------------------------
;some intro texts are at beginning of the game copied to memory area of printer buffer to save some data
IntroText1	.EQU 23296
	
IntroText2	.EQU 23296 +73
	
	
IntroText3  .EQU 23296 +102
	
	
IntroText4  .EQU 23296 +169
	
IntroText5	.EQU 23296 +234
	
IntroText6  
	.BYTE 241,84,65,89,219,65,33,91,14,214,12,212,220,133,153,65,144,200,218,78,163,221,96,87,158,207,54,206,13,21,145,91,21,84,217,9,35,159,21,27,154,1
	.BYTE 145,93,162,5,76,155,91,143,187,5,33,197,229,197,220,213,156,5,29,27,162,5,207,83,172,144,12,211,41,27,104,73,116,212,145,65,110,211,26,69,112,197
	.BYTE 232,153,219,65,118,91,106,76,44,220,162,5,206,204,40,82,117,29,8,143,173,27,48,83,161,82,221,8,11,155,98,71,69,27,164,129,177,76,248,93,161,76,44
	.BYTE 15,149,1,162,79,118,193,113,27,104,78,206,207,162,5,151,77,12,150,43,19,224,25 
	
	
IntroText7
	.BYTE 241,68,44,208,77,5,221,8,42,82,217,9,152,207,177,82,73,83,237,8,46,91,98,86,41,27,14,211,75,80,97,91,98,70,46,193,113,29,121,148,43,155,145,76,73
	.BYTE 68,219,206,219,194,155,204,45,5,237,5,26,14,123,15,58,69,159,20,65,89,216,207,116,201,33,82,41,29,162,5,76,155,91,143,187,5,33,197,216,91,156,9,146,84
	.BYTE 168,76,237,8,75,135,248,78,125,27,132,129,29,9,24,76,224,19
	
IntroText8	.EQU 23296 +392
	
	
IntroText9
	.BYTE 186,25,216,82,46,217,125,91,161,76,98,78,62,205,46,193,19,213,167,73,167,193,154,82,248,221,239,133,162,5,219,89,146,65,34,65,118,210,41,149,57
	.BYTE 91,145,77,10,78,41,29,14,205,204,212,44,153,221,78,162,76,219,143,191,193,21,84,218,84,221,193,159,67,99,211,44,155,162,1,118,193,118,66,121,25
	.BYTE 217,88,129,67,161,68,231,87,46,200,13,133,220,133,25,78,163,25,220,133,25,73,177,68,216,93,105,83,152,71,46,198,147,205,219,206,46,207,54,207,172
	.BYTE 155,154,9,132,221,186,9,26,27,184,83,217,207,75,135,221,15,221,82,11,143,159,29,0

IntroText10 .EQU 23296 +469
	
	
IntroText11
	.BYTE 241,84,65,89,220,212,12,148,41,27,46,16,99,210,75,135,221,8,46,194,12,197,232,78,39,196,125,82,216,207,117,1,29,27,184,83,219,15,157,28,234,91
	.BYTE 49,65,150,212,64,84,220,207,105,84,66,78,62,194,9,29,64,83,218,1,132,5,113,68,231,73,221,193,117,27,203,213,221,15,217,207,221,8,44,133,231,83
	.BYTE 41,91,186,1,166,200,12,16,43,133,38,212,126,207,172,155,28,133,191,65,113,27,153,65,144,200,217,143,150,193,118,91,155,213,144,197,158,207,55,77
	.BYTE 204,137,9,9,11,155,91,143,187,5,33,197,224,0
	
IntroText12
	.BYTE 241,84,65,73,150,211,26,69,112,197,218,83,220,18,72,197,97,83,158,198,124,157,125,82,216,201,178,76,76,193,162,79,119,7,126,193,113,27,145,67
	.BYTE 125,133,151,84,65,91,110,82,72,68,72,78,218,5,146,84,9,197,231,64
	
IntroText13
	.BYTE 240,9,221,15,122,219,162,5,217,129,157,5,157,27,28,129,53,27,11,132,236,197,166,207,49,155,123,155,110,91,83,213,147,133,207,29,162,5,221,18,13
	.BYTE 133,102,212,123,203,219,69,220,201,199,85,113,86,43,148,53,76,217,1,204,220,78,197,177,78,165,65,99,25,232,80,132,143,8,200,41,27,162,5,216,83
	.BYTE 161,82,122,68,231,64	

IntroText14
	.BYTE 240,14,120,143,38,91,184,82,113,68,235,69,219,198,216,83,161,82,122,68,233,5,49,78,153,91,158,83,161,77,248,93,67,215,45,133,151,196,239,73,166
	.BYTE 215,12,219,153,84,221,15,233,5,157,18,126,91,11,153,232,80,132,143,8,200,75,135,237,133,156,197,103,29,0
	
IntroText15
	.BYTE 240,23,65,78,218,91,145,65,98,83,41,27,162,1,167,193,77,27,184,83,237,15,126,204,13,5,221,15,217,86,9,5,221,8,46,205,76,211,75,5,231,65,99,27,78
	.BYTE 195,125,76,38,196,126,215,12,219,132,133,156,201,113,219,162,5,233,74,40,212,216,149,165,15,119,29,234,91,155,15,187,25,217,5,152,197,113,5,38,212
	.BYTE 126,212,65,93,12,212,44,143,73,27,157,82,48,67,47,0
	
	
;--------------------------------------
Outro
	
;screen 1	
	CALL ClearScreen

	LD HL,20480+96
	LD DE,OutroText1
	CALL TypeText
	LD HL,23136
	LD BC,32*256+2
	CALL FadeIn
	
	LD HL,16384+236
	LD BC,7*256+8
	CALL DrawBorder
	LD HL,18510
	LD DE,EscapeShip
	CALL DrawTile

	CALL WaitForPressingFire
	
;screen 2
Outro2	
	CALL ClearScreen
	LD HL,20480+96
	LD DE,OutroText3
	CALL TypeText
	LD HL,23136
	LD BC,32*256+2
	CALL FadeIn
	

	LD HL,16384+163
	LD BC,26*256+13
	CALL DrawBorder
	
	LD HL,BasePictureData
Outro3	
	LD A,(HL)			;draw space station
	OR A				;it consists of several parts
	JR Z,Outro4			;which are drawn in a loop
	
	LD B,72
	LD C,(HL)			;screen position
	INC HL
	
	LD E,(HL)			;tile
	INC HL
	LD D,(HL)
	INC HL
		
	PUSH HL
	PUSH BC
	POP HL
	CALL DrawTile
	POP HL
	JR Outro3
	

Outro4
;draw moving pixel(ship) entering the base
	LD HL,18432+7*256+231		;start position			
	LD E,8						;shifted pixel
	LD D,0
	LD C,29						;cycles
		
Outro5
	LD B,10							;delay
Outro55
	HALT
	DJNZ Outro55	

	LD (HL),D						;restore background
;going one pixel line up
	DEC H 							;change pixel line
	LD A,H
	AND 00000111B
	CP 7
	JR NZ,Outro6
	
	LD A,L 							;changecharacterline if necessary
	SUB 32
	LD L,A
	LD A,H
	ADD A,8
	LD H,A


Outro6	
	;move pixel right 	
	RRC E
	RRC E
	LD A,E
	CP 128
	JR NZ,Outro65
	INC L							;move byte right if necessary
	
Outro65
	LD D,(HL)						;store background
	LD A,E
	OR D							;combine pixel	with background	
	LD (HL),A						;write pixel
	
	DEC C
	JR NZ,Outro5
	


	
	
Outro7
	CALL WaitForPressingFire

;screen 3	
	CALL ClearScreen
	LD HL,18432+64
	LD DE,OutroText4
	CALL TypeText
	LD HL,22848
	LD BC,32*256+4
	CALL FadeIn
	CALL WaitForPressingFire
	JP GameOver
	
	


	



;---------------------
BasePictureData
	.BYTE 76
	.WORD Base1
	.BYTE 78
	.WORD Base1
	.BYTE 12
	.WORD Base2
	.BYTE 41
	.WORD Base3
	.BYTE 50
	.WORD Base3
	.BYTE 80
	.WORD Base4
	.BYTE 75
	.WORD Base5
	.BYTE 116
	.WORD Base6
	.BYTE 217
	.WORD Base7
	.BYTE 0
	
;----------------------
EscapeShip	
	.BYTE 3,3
	.BYTE	  16
	.BYTE	  0, 28, 54,107, 97, 93,162,162
	.BYTE	  0,  0,  0,  0,  0,  0,128,128
	.BYTE	  0,  1,  1,  1,  5,  5, 13, 12
	.BYTE	220,162,213,170,253,128,126,129
	.BYTE	128,128, 64, 64, 80, 80, 88, 88
	.BYTE	 29, 29,  0,  0,  0,  0,  0,  0
	.BYTE	 52,106,117, 58, 20, 28,  8,  8
	.BYTE	156,156,  0,  0,  0,  0,  0,  0
	.BYTE	  0, 71, 71,  7, 71,  7,  7, 66
	.BYTE	  7

Base1
	.BYTE 2,3
	.BYTE	255,  0,127, 66, 68, 72,127,  0
	.BYTE	255,  1,253, 37, 73,149,253,  1
	.BYTE	255, 73, 73,255,248,252,254,255
	.BYTE	255, 37, 37,255, 63,127,255,255
	.BYTE	224,239,232,239,224,255,170, 85
	.BYTE	 31,223, 95,223, 31,255,170, 85
	.BYTE	 71, 71, 71, 71, 71, 71
Base2
	.BYTE 4,2
	.BYTE	  16
	.BYTE	255,194,196,200,255,  0,127, 24
	.BYTE	255, 39, 75,151,255,  0,255,  0
	.BYTE	  0, 64, 32, 80, 32, 80,160,208
	.BYTE	  2,  0,  2,  2,  2,  7,  7,  0
	.BYTE	  3,  3,  3,  3,  3,  3,  3,  0
	.BYTE	210,162, 82,162,210,162, 82,  0
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  0, 71, 71,  7,  7,  7,  7,  0
	
Base3
	.BYTE 2,4
	.BYTE	  3,  7,  6,  3,  0,  1,  1, 13
	.BYTE	128, 64, 64,128,  0,  0,  0, 48
	.BYTE	  1,  1,  1, 13,  1,  1,255,  0
	.BYTE	  0,  0,  0, 48,  0,  0,254,  0
	.BYTE	255,131,187,130,252,254,  0, 48
	.BYTE	254,130,186,130,126,254,  0, 24
	.BYTE	 40, 48, 40,  0, 16, 16, 76, 16
	.BYTE	 20, 24, 20,  0,  8,  8, 50,  8
	.BYTE	  7,  7,  7,  7, 71, 71, 71, 71
Base4
	.BYTE 2,3
	.BYTE	124,126,117,107,118,109, 90,109
	.BYTE	  0,192,232, 88,184,104,216,184
	.BYTE	 80, 34,101,111,119, 88, 54,109
	.BYTE	  0,170, 84,254,254,  0,168,104
	.BYTE	 90, 53,123, 86, 45, 91,118,109
	.BYTE	216,184,104,216,184,104,216,128
	.BYTE	  7,  7,  7,  7,  7,  7
Base5
	.BYTE 1,2
	.BYTE	  0,  0,  0,  0,  0,  0,128,192
	.BYTE	222,190,170,148,192,128,  0,  0
	.BYTE	  7,  7
	
Base6
	.BYTE 1,1
	.BYTE	128,192,224,224,224,128,  0,  0
	.BYTE	  7
	
Base7
	.BYTE 3,3
	.BYTE	  0, 56,116,234,210,162, 68, 56
	.BYTE	  0,  0,  0,  0,  0,  0,  1,  3
	.BYTE	  0,  0,  7, 31,127,255,255,255
	.BYTE	  0,  0,  0,  0,  0,  0,  0,  0
	.BYTE	  7, 15, 31, 63, 63,127,127,255
	.BYTE	255,255,227,192,192,128,128,  0
	.BYTE	  0,  1,  1,  1,  3,  3,  3,  3
	.BYTE	252,112,  1,  0,  0,  0,  0,  0
	.BYTE	 64,192,128,  0,  1,  7, 15, 15
	.BYTE	 71,  4,  4,  0,  4, 12,  1, 12
	.BYTE	 12

;-------------------
OutroText1
	.BYTE 240,5,113,201,113,83,220,143,12,155,11,132,220,143,26,197,166,199,121,83,221,80,235,5,13,137,113,219,162,5,216,83,161,82,122,68,216,133,66,78,32,5

OutroText3
	.BYTE 240,25,125,91,152,70,43,25,216,82,146,86,46,193,166,193,118,197,12,148,71,79,144,137,162,78,62,211,160,84,75,206,1
	
OutroText4
	.BYTE 240,27,222,219,222,219,216,207,113,210,13,21,96,84,75,206,159,198,239,91,222,212,65,91,110,82,72,68,72,78,218,5,146
	.BYTE 84,9,197,218,83,236,18,44,197,149,133,38,198,124,155,53,84,172,133,217,197,113,82,13,9,123,147,0