StartMenu
;display start game menu						

 CALL ClearScreen
  		
 LD HL,16384
 LD BC,32*256+24
 CALL DrawBorder

 LD HL,16384+76
 LD DE,TitleText
 CALL TypeText

 LD HL,16384+172
 LD DE,MenuText
 CALL TypeText
 
 LD HL,16384+170
 LD DE,Numbers+38
 CALL DrawTile

 LD HL,18432+10
 LD DE,Numbers+76
 CALL DrawTile
		
 LD HL,18432+106
 LD DE,Numbers+114
 CALL DrawTile						

 LD HL,18432+202
 LD DE,Numbers+152
 CALL DrawTile
 
 LD HL,20480+103
 LD DE,AuthorText
 CALL TypeText
 


  
;scan keyboard during menu					
TestMenuKeys
	LD BC,63486
	IN A,(C)
		
	BIT 0,A				;1
	CALL Z,ChooseKeys
	
	
	BIT 1,A				;2
	CALL Z,ChooseJoystick
	
	BIT 2,A				;2
	JP Z,Intro
	
	
	BIT 3,A				;4
	JP Z,BeginGame
	
;advanced hidden settings	
	LD BC,61438
	IN A,(C)
	
	
	BIT 0,A
	JR Z,UpdateJetmanAttr
	
	BIT 1,A
	JR Z,PlayJetSound
		
	JR TestMenuKeys
		

ChooseKeys
 PUSH AF
 CALL MenuSound
 XOR A
 LD (KeysOrJoystick),A
 POP AF
 RET
		
ChooseJoystick
 PUSH AF
 CALL MenuSound
 LD A,1		
 LD (KeysOrJoystick),A	
 POP AF
 RET
 
UpdateJetmanAttr
	LD HL,JetmanAttrs
	JR Menu_UpdateVariable	

PlayJetSound 
	LD HL,JetSound
	
Menu_UpdateVariable	
	LD A,(HL)
	CPL
	LD (HL),A
	LD B,4					;border color green - enabled
	OR A
	JR Z,Menu_UpdateVariable2
	LD B,2					;border color red - disabled

Menu_UpdateVariable2
	LD A,B	
	OUT (254),A
	CALL Wait2Seconds
	XOR A
	OUT (254),A
	JR TestMenuKeys
 
 
KeysOrJoystick 	.BYTE 0		;0-keys, 1-joystick
JetmanAttrs		.BYTE 0
JetSound		.BYTE 0
 
;-------------------------------------------
;menu seen during game
DrawGameMenu
	LD HL,MenuData
	CALL DrawRoom			;for menu drawing the same subroutine
							;as for location drawing is used

	CALL DrawMenuNumbers
	CALL DrawMenuItems
	CALL DrawItemSelection
	RET	
	
;---------------------		
DrawMenuNumbers		
	
	LD A,(Lives)			;draw nr of lives
	CALL FindMenuNumberTile
	LD HL,16384+53
	CALL DrawTile
		
	LD A,(Disks)			;draw nr of disks
	CALL FindMenuNumberTile
	LD HL,16384+35
	CALL DrawTile

DrawMenuNumbers1	
	LD A,(Energy)			;draw numbers expresssing energy 
	LD B,0
DrawMenuNumbers2
	INC B
	SUB 10
	JR NC,DrawMenuNumbers2
							;number of tens is in B
	ADD A,10 				;number of ones is in A
		
	DEC B
	PUSH AF
	CALL FindMenuNumberTile1		
	LD HL,16384+59
	CALL DrawTile
	POP AF
	
	CALL FindMenuNumberTile		
	LD HL,16384+61
	CALL DrawTile
	RET

;------------
FindMenuNumberTile
	LD B,A
FindMenuNumberTile1
	INC B
	LD HL,Numbers-38
	LD DE,38
FindMenuNumberTile2
	ADD HL,DE		
	DJNZ FindMenuNumberTile2
	EX DE,HL
	RET
	
	
	
;--------------------------	
DrawMenuItems
;first item	
	LD HL,16384+7			;position
	LD A,(FirstItem)		;item nr
	CALL DrawMenuItems2
;second item	
	LD HL,16384+14			;position
	LD A,(SecondItem)		;item nr
	CALL DrawMenuItems2
	RET
	
;----	
DrawMenuItems2
	LD BC,3*256+3
	LD DE,EmptySpace		;clear old item
	PUSH BC
	PUSH HL
	PUSH AF
	CALL TileBlock
	
	POP AF					;find item sprite
	POP HL
	POP BC
	OR A					;no item in this slot so just draw empty space and return
	RET Z
	
	PUSH HL
	LD HL,InitialItemData-2
	LD DE,5
DrawMenuItems3
	ADD HL,DE
	DEC A
	JR NZ,DrawMenuItems3
	LD E,(HL)				;sprite address to DE
	INC HL
	LD D,(HL)
	
	POP HL					;restore position
	CALL DrawTile0			;draw sprite
	RET

;--------------------------	
DrawItemSelection
	LD HL,16384+43
	LD DE,ItemArrowLeft
	LD A,(ItemSelection)
	OR A
	JR Z,DrawItemSelection2
	LD DE,ItemArrowRight
DrawItemSelection2
	CALL DrawTile
	RET
	

;------------
ItemArrowLeft
	.BYTE 2,2
	.BYTE	255,255,252,251,247,239,223,159
	.BYTE	255,255,  7,215,231,215,231,215
	.BYTE	 47,151,203,229,242,248,252,255
	.BYTE	231,215,231, 87,167,  7,  7,255
	.BYTE	  1,  1,  1,  1	
ItemArrowRight
	.BYTE 2,2
	.BYTE	255,255,224,235,231,235,231,235
	.BYTE	255,255, 63,223,239,247,251,249
	.BYTE	231,235,231,234,229,224,224,255
	.BYTE	244,233,211,167, 79, 31, 63,255
	.BYTE	  1,  1,  1,  1

		
;--------------------------	
MenuData
;blocks
	.BYTE 139,30,1,1
	.BYTE 142,10,1,103
	.BYTE 146,2,1,11
	.BYTE 0
	.BYTE 0
	.BYTE 0
;tiles
	.BYTE 137,0
	.BYTE 137,18
	.BYTE 137,24
	.BYTE 138,5
	.BYTE 138,23
	.BYTE 138,31
	.BYTE 140,6
	.BYTE 140,13
	.BYTE 141,10
	.BYTE 141,17
	.BYTE 143,33
	.BYTE 144,51
	.BYTE 145,57
	.BYTE 0
	.BYTE 0
	.BYTE 0
	.BYTE 0;no enemy

 
;-------------READ PLAYER INPUT-------------
;--------------------------------------	
GetPlayerInput
	LD A,(KeysOrJoystick)
	OR A						;keyboard or joystick
	JR Z,KeyboardControl
	
JoystickControl
	LD BC,31
	IN A,(C)
	RET
	
KeyboardControl
;the aim is to set bits of A register as it would be joystick input
	LD D,0
	LD BC,57342; O,P	
	IN A,(C)
	CPL
	AND 00000011B
	LD D,A
	LD BC,64510;Q
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	OR D		
	LD D,A		
	LD BC,65022;A
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	OR D
	LD D,A
	LD BC,32766
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	RLA
	OR D ;ready
	RET
		

;------------	
WaitForPressingFire
	PUSH BC
	PUSH DE
	CALL GetPlayerInput
	POP DE
	POP BC
	BIT 4,A				;check if fire was pressed
	RET NZ				;end of waiting for fire if fire was pressed
	JR WaitForPressingFire 
	
GameOver
	CALL ClearScreen
	LD HL,18432+139
 	LD DE,GameOverText
 	CALL TypeText	

 	LD B,100 
GameOver2
	HALT
	DJNZ GameOver2
	JP Start1		;forget about all routine CALLs and start the game from begining

 
;---------------
;menu texts
TitleText
	.BYTE 241,8,44,137,160,71,40,0
	
MenuText
	.BYTE 89,89,19,193,145,29,142,193,219,219,134,211,128,67,47,93,89,77,132,212,123,157,83,217,157,9,26,221,236
	.BYTE 133,9,29,75,148,147,196,168,212,75,206,239,83,160,82,167,71,11,69,0

AuthorText
	.BYTE 144,70,15,197,219,73,14,135,14,205,106,88,0
	
GameOverText
	.BYTE 56,77,46,207,177,82,0