;---------------------------------
;main game loop
MainLoop
;check jetman collisions with enemies
 CALL CheckCollisions
 CALL CheckCollisions_Water


;is jetman making a turn?
 LD  A,(TurnStatus)
 OR A
 JR Z,MainLoop2								;no turning, read keyboard for player input

;turning 
 CP  1
 CALL  Z,TurnWalkToStand					;turning from walking position to standing position	(inc. displaying jetman)

 LD  A,(TurnStatus)
 CP  2
 CALL  Z,TurnStandToWalk					;turning from standing position to walking position	(inc. displaying jetman)
 JR MainLoop								;repeat until turning is finished

;walking, flying,standing,using 
MainLoop2	
 CALL ReadInput								;set variables :Flying status and Walking dir responsible for movement direction
 											;flying Status: 2-up 1-down 0-standing		
 						
MainLoop3 											
 LD A,(TurnStatus)							;if jetman decided to turn, go to proper code
 OR A
 JR NZ,MainLoop											
 
 CALL FindJetmanSprite						;determine jetman sprite by his walking, flying and standing status
 
 CALL  DisplayMovingObjects					;draw jetman and enemy (Halt command in the routine middle)

 LD A,(PlayerInput)							;scan for pressing down
 BIT 2,A
 CALL NZ, SwitchChosenItem
 
 LD A,(PlayerInput)							;scan for pressing fire
 BIT 4,A
 CALL NZ, PressFire
 					
 
 CALL MoveJetman							;change jetman position based on input
			
 JR MainLoop
 
GameCycle .BYTE 0
;---------------------------------	

;deal with turning around
;when jetman turn, he can't do anything else
;-------------------------------- 
;turning from walking to standing
TurnWalkToStand
	XOR  A
	LD  (WalkingDir),A						;set that player isn't walking

TurnWalkToStand2
	LD  HL,TurnOrder1-1						;read start of animation frames of turning while walking
	LD A,(FlyStatus)						;is player flying?
	OR A				
	JR Z,TurnWalkToStand3
	LD HL,TurnOrder1Fly-1					;read start of animation frames of turn while flying

TurnWalkToStand3 
	LD  A,(CurrentTurnFrame)				;find current animation frame
	ADD A,L
	LD  L,A
	LD  A,0
	ADC A,H
	LD  H,A
	LD  B,(HL)  							;turning animation frame into B

	PUSH BC
	CALL CheckGround						;when turning jetman may be falling, so check ground under his feet
 	POP BC		
	
 	CALL  DisplayMovingObjects				;draw jetman and enemy
 	CALL Fly								;change position - jetman may fly while turning
 
	LD  HL,CurrentTurnFrame					;next animation frame
	INC  (HL)
 	LD  A,(HL)
 	CP  11									;number of frames+1 to make a full turn 									
 	RET NZ									;turning not completed yet
 	
	XOR  A									;set end of turning 
	LD  (TurnStatus),A
	LD  (StandingStatus),A 					;0 means standing 
	RET						
	
;------- 	
TurnOrder1
	.BYTE 1,1,1,9,9,9,10,10,10,11
TurnOrder1Fly
	.BYTE 12,12,12,13,13,13,14,14,14,15		

		
;-------------------------------- 
;turning from  standing to walking
TurnStandToWalk
	XOR  A
	LD  (WalkingDir),A						;set that player isn't walking

TurnStandToWalk2
	LD  HL,TurnOrder2-1						;read start of animation frames of turning while walking
	LD A,(FlyStatus)						;is player flying?
	OR A				
	JR Z,TurnStandToWalk3
	LD HL,TurnOrder2Fly-1					;read start of animation frames of turn while flying			

TurnStandToWalk3 
	LD  A,(CurrentTurnFrame)				;find current animation frame
	ADD  A,L
	LD  L,A
	LD  A,0
	ADC  A,H
	LD  H,A
	LD  B,(HL)  							;turning animation frame into B

	PUSH BC
	CALL CheckGround						;when turning jetman may be falling, so check ground under his feet
	POP BC		
	
	CALL  DisplayMovingObjects				;draw jetman and enemy
	CALL Fly								;change position - jetman may fly while turning
 
	LD  HL,CurrentTurnFrame					;next jetman animation frame
	INC  (HL)
	LD  A,(HL)
	CP  11 									;number of frames to make a full turn  
	RET  NZ									;turning not completed 
 
 XOR  A										;end of turning 
 LD  (TurnStatus),A
 LD  A,1
 LD  (StandingStatus),A 					;1 means not standing 
 RET
 
;------- 
TurnOrder2
 .BYTE 11,11,11,10,10,10,9,9,9,1
TurnOrder2Fly
 .BYTE 15,15,15,14,14,14,13,13,13,12
		
;--------------------------
;set initial turning parameters when turn is made
TurnToStand
	LD  A,1
	LD  (TurnStatus),A
	LD  (CurrentTurnFrame),A 
	RET
 
;-------------
TurnFromStandToRight
 	LD A,2
 	LD  (TurnStatus),A
 	DEC  A
 	LD  (CurrentTurnFrame),A
 	LD  A,(FacingDir)
 	CP  255
 	CALL Z,MirrorJetman
 	LD  A,1
 	LD  (FacingDir),A
 	RET
 
;-------------
TurnFromStandToLeft
 
	LD  A,2
	LD  (TurnStatus),A
	DEC A
	LD  (CurrentTurnFrame),A
	LD  A,(FacingDir)
	CP  1
	CALL Z,MirrorJetman
	LD  A,255
	LD  (FacingDir),A
	RET


;---------------------------------------- 
;read input from keyboard or joystick and set variables about jetman movement
ReadInput
 XOR  A
 LD  (WalkingDir),A
 LD (PlayerInput),A

 CALL GetPlayerInput				;reads player input from keyboard or joystick into A register
 LD (PlayerInput),A
 
;------ 
ReadInput_FlyingUp
;check if jetman is flying up
 LD  HL,FlyStatus
 BIT 3,A  							;read input bit responsible for flying up
 JR  Z,CheckFly2  					;no flying up 
 LD  (HL),2 						;status = flying up 
 JR ReadInput_Right 

CheckFly2
;no flying up ,so check if falling down or standing 
 PUSH  AF
 LD  (HL),1							;assume status = falling down 
 CALL CheckGround					;if ground found, change flying status to 0
 POP  AF
 ;----- 
  
ReadInput_Right
;check walking right
 BIT 0,A 							;check if trying to walk right
 JR  Z,ReadInput_Left				;no walking right so go checking walking left

 
 LD  A,(StandingStatus)				;player tries to walk right
 OR  A								;is he already in walking position or is he standing?
 JP  Z,TurnFromStandToRight         ;if he was standing, he must turn right first

 LD  A,(FacingDir)                  ;if jetman was walking left and tries to walk right now
 CP 255 							;he must first turn to standing position
 JR  Z,TurnToStand					
 
 
;if above didn't happen -> just walk right 
 LD  A,1
 LD  (WalkingDir),A
 LD  (FacingDir),A
 LD  (StandingStatus),A				;not 0 means no standing
 RET

		

ReadInput_Left
;check walking left
 BIT  1,A 							;check if trying to walk right
 RET  Z								;no walking left and no walking right so jetman is standing

 LD  A,(StandingStatus)				;player tries to walk left
 OR  A								;is he already in walking position or is he standing?
 JP  Z,TurnFromStandToLeft          ;if he was standing, he must turn left first
 
 LD  A,(FacingDir)					;if jetman was walking right and tries to walk left now									
 CP 1 								;he must first turn to standing position
 JP  Z,TurnToStand

;if above didn't happen -> just walk left 
 LD  A,255
 LD  (WalkingDir),A
 LD  (FacingDir),A
 LD  (StandingStatus),A				;not 0 means no standing				
 RET
 
PlayerInput .BYTE 0
 

;------------------------------------
FindJetmanSprite
;determine jetman sprite by his walking, flying and standing status
;place sprite nr into B register
	LD  A,(StandingStatus)						;is jetman standing?				
	OR  A
	JR  NZ,FindJetmanSprite2

;standing (on ground or in the air)  
	LD  B,11 									;ground standing  sprite
	LD A,(FlyStatus)							;is jetman flying?
	OR A			
	RET Z
	LD B,15										;floating in the air sprite
	RET	
				
;flying left or right
FindJetmanSprite2
	LD  A,(FlyStatus)							;is jetman flying? 
	OR  A
	JR  Z,FindJetmanSprite3						;no flying, so walking animation 
	LD  B,12 									;flying sprite
	RET 

;walking left or right
FindJetmanSprite3
 	LD  HL,OrderOfFrames-1						;jetman is walking, count walking frame 
	LD  A,(CurrentFrame)
	LD  E,A
	LD  D,0
	ADD  HL,DE 
	LD  B,(HL)
	RET 
;---------------------------------------
DisplayMovingObjects
;create in buffers jetman and enemy sprites ready for display (shifted properly)
;number of jetman sprite to be displayed is in B now
 
 CALL PrepareJetman								;preparing jetman sprite in buffer
 LD A,(EnemyNr)
 OR A
 JR Z,DisplayMovingObjects2						;no enemy
 CP 7
 JR Z,DisplayMovingObjects2						;in case of guns and bullets also don't prepare enemy in buffer			
 
 CALL PrepareEnemy                          	 ;preparing enemy sprite in buffer (if enemy exists in curent location)
 
DisplayMovingObjects2									
 HALT

 CALL  DrawBackground 							;restore background behind jetman 
												;(restore background graphics and attributes)
			
;which enemy should be displayed
 LD A,(EnemyNr)
 OR A
 JR Z,DisplayMovingObjects22				;no enemy
 
 CP 7
 JR NZ,DisplayMovingObjects21				;standard enemy
 
 CALL DisplayBullets						;bullets						
 JR DisplayMovingObjects22					
  					
DisplayMovingObjects21				
 CALL DisplayEnemy							;clear enemy at old position and draw him at new position
 
DisplayMovingObjects22									
 CALL DrawItems
 				
 CALL DrawJetmanAttr							;store attributes behind jetman and draw jetman attributes
 CALL DrawJetman 								;draw jetman sprite
 
  
 	
 												;flying sound
 LD A,(FlyStatus)
 OR A
 JR Z,DisplayMovingObjects3
 
 LD A,(JetSound)
 OR A
 JR NZ,DisplayMovingObjects3					;in start menu sound was disabled				 	
 
FlySound 
 LD B,10
FlySound1
 XOR A
 OUT (254),A 
 LD A,R
FlySound2 
 DEC A
 JR NZ,FlySound2
 LD A,16
 OUT (254),A
 DJNZ FlySound1 
 
 
DisplayMovingObjects3									 	
 	CALL ChangeEnemyPos							;changing enemy position for next frame	
	                                     
	LD  HL,(NewJetmanPos)						;change jetman position
	LD  (OldJetmanPos),HL                       ;new position becomes old position 

 	CALL PrepareBackgroundForDrawing			;reorganise stored background data, so they could
 												;be drawn faster later when it will be resored

	LD HL,(NewJetmanAttrPos)					;new attribute position becomes old attribute position
	LD (OldJetmanAttrPos),HL
	
	RET			

;----------
MoveJetman
 ;change position and animation frame
 LD A,(WalkingDir)
 OR A
 JR Z,ChangeWalkPos								;standing=no animation 
 
 LD  HL,CurrentFrame							;change walking animation frame
 INC  (HL)
 LD  A,(HL)
 CP  30
 JR  NZ,ChangeWalkPos
 LD  (HL),1
 
ChangeWalkPos
 												;count new position 
 LD  HL,JetmanX
 LD  A,(WalkingDir)
 OR  A
 JP  Z,Fly 										;no moving left or right, but maybe going up or down 
 
 CP  255  										;left or right 
 JR  Z, WalkLeft
 
 
;----------------	
WalkRight
 LD A,(HL)
 CP 222											;right screen edge?
 JR NZ,CheckObsRight

;hit right edge,change screen
 JP OneScreenRight 								;must be JP, not CALL				

CheckObsRight
 LD DE,(NewJetmanAttrPos)
 INC DE
 INC DE											;check obstacles right of jetman
 INC DE											;go to attribute character right of jetman		
 
 LD B,6											;jetman is 6 characters high
CheckObsRight2
 LD A,(DE)
 AND 00000111b									;extract ink from attribute of square right to jetman
 OR A											;0 means black ink = wall
 JR Z, Fly										;if hit wall don't change position
 LD A,E
 ADD A,32
 LD E,A
 LD A,0
 ADC A,D
 LD D,A											;go one square down while checking obstacle
 DJNZ CheckObsRight2										

;no obstacle met, go right				
 INC  (HL)
 INC  (HL) 										;change X position 
 JR  Fly
 
 
;----WALK LEFT-----
WalkLeft
 LD A,(HL)										;if standing at position rotated 2,4 or 6 pixels don't check wall collision
 AND 00000111b									;because it would  block jetman in some cases
 OR A																	
 JR NZ,WalkLeft2								;jetman can for sure still walk
 
 LD A,(HL)
 OR A											;check if left screen reached				
 JP Z,OneScreenLeft 							;must be JP, not CALL				
 
CheckObsLeft
 LD DE,(NewJetmanAttrPos)						;check obstacles left of jetman
 DEC DE											;go to first attribute  left of jetman
 LD B,6											;jetman is 6 characters high
CheckObsLeft2
 LD A,(DE)
 AND 00000111b									;extract ink from attribute of square left to jetman
 OR A											;0 means black ink = wall
 JR Z, Fly										;if hit wall don't change position
 LD A,E
 ADD A,32
 LD E,A
 LD A,0
 ADC A,D
 LD D,A											;go one square down
 DJNZ CheckObsLeft2								;repeat 6 times
		
;no obstacles met, go left		
WalkLeft2 
 DEC  (HL)
 DEC  (HL) 
		
;flying
;-------------------------------		
Fly
 LD HL,JetmanY
 LD  A,(FlyStatus)
 OR  A											;is jetman flying?
 JR  Z,WalkEnd 									;no flying 
 CP  1
 JR Z,FallDown									;status = 1 -> falling down, status = 2 -> going up,

;---------------		 
FlyUp
;check going up

 LD DE,(NewJetmanAttrPos)  						;check if jetman hits ceiling
 
 LD A,E
 SUB 32
 LD E,A
 JR NC,CheckCeiling1
 DEC D											;go one character up					
 
CheckCeiling1 
 LD B,3											;jetman is 3 characters wide	
CheckCeiling2
 LD A,(DE)
 AND 00000111b									;0 means black ink -> hit ceiling
 OR A
 JR Z, CeilingFound
 INC DE
 DJNZ CheckCeiling2
 JR FlyUp2										;no ceiling
 
 ;----		
CeilingFound
;there is ceiling above jetman, but we must check if jetman position is "equal"	
;(there isn't any single pixel line free between jetman and ceiling)	

 LD A,(HL)										;jetman Y into A
 		
 AND 00000111b									;last three bits = 0 -> equal position
 OR A
 JR NZ,FlyUp2									;jetman can still go up a few (less than 8)pixels
 JR WalkEnd										;jetman can't go up any more		

;-----								
;going up confirmed
FlyUp2 
 DEC  (HL)										;go up
 DEC  (HL)
 LD A,(HL)
 CP 30											;top of playing screen?
 JR NZ, WalkEnd												 
 JP OneScreenUp									;change location

;---------------	
FallDown
;going down
;hiting ground is checked elsewhere (CheckGround routine)

 INC  (HL)
 INC  (HL)
 LD A,(HL)
 ;CP 146 										;check bottom of screen
 CP 144
 JR NZ,WalkEnd	 
 JP OneScreenDown								;change location


		


;------------------------		
WalkEnd
 DEC  HL 										;go to Jetman X		
 LD  B,(HL)
 INC  HL 
 LD  C,(HL) 									;BC loaded with XY coordinates 
 LD  A,B
 AND  00000111b
 LD  (JetmanRotation),A
 
 CALL  XYtoHL									;XY coordinates converted to HL coordinates
 LD  (NewJetmanPos),HL							;store new HL jetman position
 
;store pixel line screen addresses of jetman new position in buffer to be used later 
 PUSH HL
 LD DE,JetmanNewLineAdresses
 LD B,48
 CALL PrepareLineAddressesInBuffer
 POP HL
 
 CALL CountAttrPos								;count attribute address 
 RET

  
 
 
;--------------
OrderOfFrames			.BYTE 1,1,1,2,2,2,3,3,3,3,4,4,4,1,1,1,5,5,5,6,6,6,7,7,7,7,8,8,8
		 
;---------------------------------------- 
CheckGround	
;check ground under jetman feet		
	LD HL,(NewJetmanAttrPos)
 	LD DE,192						;6*32 where 6 is height of jetman
	ADD HL,DE						;count attr position of ground below jetman feet

;jetman facing left/right = slightly different ground checking routine
	LD A,(FacingDir)
	CP 1
	JR Z,CheckGround1
	LD A,(HL)
	AND 00000111b
	OR A 							;leftmost square checked only if facing right			
	JR Z,GroundFound	
	
CheckGround1
	INC L					 
	LD B,2							;change jetman width
	
CheckGround2			
	LD A,(HL)
	AND 00000111b 					;extract ink
	OR A							;black ink means solid ground		
	JR  Z,GroundFound
	INC L 							;check all squares below jetman
	DJNZ CheckGround2	
	RET 							;return with no ground found

GroundFound			
	LD HL,FlyStatus 
	LD (HL),0 						;status=standing						
 	RET

 	
;----------------------------
CheckCollisions
;check collisions with enemies
 LD A,(EnemyNr)
 OR A
 RET Z								;no enemy in this location
 
 CP 7
 JP Z,CheckCollisions_Bullets		;for bullets there is another subroutine
 
 
 LD C,22							;enemy height
 CP 5								;enemy = worm ? 
 JR NZ,CheckCollisions2
 LD C,14							;worm is smaller than rest of enemies

CheckCollisions2
;compare player and enemy coordinates 

;compareX 
 LD A,(EnemyX)
 LD B,A
 LD A,(JetmanX)
;enemy width is 24 pixels, jetman width is 48 pixels too, so to make collisions enemy X must belong to (jetmanX-24,jetmanX+24)
;but let's be generous and make enemy width 22
 SUB 22
 CP B
 RET NC								;EnemyX < JetmanX-24
 ADD A,44
 CP B
 RET C								;EnemyX > JetmanX+24
 
;compareY
 LD A,(EnemyY)
 LD B,A
 LD A,(JetmanY)
;enemy height is in C register (22 or 14 pixels), jetman height is 48 pixels, enemy Y must belong to (jetmanY-C,jetmanY+48) 
 SUB C
 CP B
 RET NC								;EnemyY < JetmanY-C
 ADD A,C
 ADD A,48
 CP B
 RET C								;EnemyY>jetmanY+48)

CheckCollisions3
;collision detected
 XOR A
 OUT (254),A
 LD HL,Energy
 DEC (HL)							;decrease energy
 
 LD A,(HL)
 OR A								;energy=0 ?
 JR Z,CheckCollisions4				;life lost
 
 
 CALL DrawMenuNumbers1				;update menu
 LD A,16							;sound
 OUT (254),A
 RET
 
CheckCollisions4
;life lost
 LD A,99							;energy back to 99 after losing a life
 LD (HL),A 
 LD HL,Lives
 DEC (HL)							;decrease number of lives
 LD A,(HL)
 CP 255
 JR Z,CheckCollisions5
 
 CALL DrawMenuNumbers
 RET
 
CheckCollisions5
;game over
 LD B,4
CheckCollisions6
 PUSH BC
 CALL MenuSound
 POP BC
 DJNZ CheckCollisions6

 LD HL,22528
 LD BC,32*256+24
 CALL FadeOut2
 
 JP GameOver
 
;----------------------------
CheckCollisions_Water
;check if jetman's head is paced over attribute 77 - water (navy paper + cyan ink + bright)
;if so, he is under water and loses health

 LD A,(BackgroundAttrBuffer+6)		;get attribute of center of second attribute line from top
 CP 77								;water?
 RET NZ								;no
 
 JR CheckCollisions3				;decrease energy and return from routine
 
;----------------------------
CheckCollisions_Bullets
	LD A,(BulletFreeTime)			;don't detect collisions if no bullets at screen
	OR A
	RET NZ
	
	LD A,(OldJetmanPos)				
	AND 00011111b					;get jetman collumn 0-31
	LD B,A
	
;1st bullet	
	LD A,(Bullet1L)
	AND 00011111b					;compare to bullet collumn
	
	CP B
	JR Z,CheckCollisions3			;collision detected
	DEC A
	CP B
	JR Z,CheckCollisions3
	DEC A
	CP B
	JR Z,CheckCollisions3
	
;2nd bullet	
	LD A,(Bullet2L)
	AND 00011111b		
					
	OR A
	RET Z							;bllet doesn't exist
	CP B
	JR Z,CheckCollisions3			
	DEC A
	CP B
	JR Z,CheckCollisions3
	DEC A
	CP B
	JR Z,CheckCollisions3
	
	RET								;no collision
 
 
;----------------------------
JetmanNewLineAdresses
;store HL addresses of every horizontal pixel line in jetman new position

						REPT 48
						.WORD 0
						ENDR