	DEVICE ZXSPECTRUM48
	ORG 23900

Start
;set interrupt
 DI
 
 LD A,24
 LD (65535),A
 
 LD A,251
 LD (65524),A
 
 LD HL,77*256+237
 
 
 LD (65525),HL

 LD A,250			;250*256=64000
 LD I,A				;the adress of interrupt code is stored at (I*256+N) (N: random value 0-255)
 					;it is memory area 64000-64257 filled with 255
 					;so the intterrupt code start will be at address 255*256+255 = 65535
 					;the next byte from 65535 is byte 0 which is in ROM and has value 243
					;so the instruction being read will be 24,243 that is JR 65524
					;and at 65524 address we have 251,237,77 which is EI,RETI command - end interrupt
					;each interrupt automatically disables interrupts, so they must be enabled again
 LD SP,65516
 IM 2
 EI
 

;copy some data to area of printer buffer and system varables (23300-23900)
 CALL CopyDataToPrinterBuffer
 
Start1
 DI
 LD SP,65516
 EI
 
;clear playing buffer and other data
 XOR A
 LD HL,64258
 LD (HL),A
 LD DE,64259
 LD BC,5*256-66 ;last bytes minus area for stack and interrupt handling
 LDIR

 JP StartMenu 		;go to game menu
	
BeginGame
 CALL MenuSound		

 ;after menu game returns here
;set initial game data
 
 XOR  A						;clear games variables to 0
 LD HL,EnemyNr
 LD B,60
BeginGame2
 LD (HL),A				
 INC HL
 DJNZ BeginGame2 
 
 LD A,7
 LD (Lives),A
 LD A,99
 LD (Energy),A
 
 
 LD  A,1
 LD  (WalkingDir),A
 LD  (FacingDir),A
 LD  (StandingStatus),A
 LD  (CurrentFrame),A
 LD  (UpdateEnemy),A
 
 ;mirror jetman sprites if necessary (after GAME OVER jetman sprites may be facing a wrong way)
 LD A,(Jetman1M)			;read first byte from jetman mask
 CP 227						;that's what first byte of jetman mask should be if jetman is mirrored correctly
 CALL NZ,MirrorJetman		;if it isn't 277, jetman sprites are facing the wrong way
		
 LD  HL,JetmanX
 LD  B,68
 LD  (HL),B 			;jetman X 
 INC  HL
 LD  C,36
 LD  (HL),C 			;jetman Y 
 LD  C,A
 CALL  XYtoHL
 LD  (NewJetmanPos),HL
 CALL CountAttrPos
 
 CALL InitialiseItems	;copy item data 
 
 

;draw first location 
 CALL ClearScreen
 CALL DrawGameMenu
  
 LD A,0*16+4
 LD (CurrentRoomNr),A
 CALL FindRoom	
 CALL DrawRoom			
 CALL ChangeRoom
 
 JP MainLoop
  	
 	
	INCLUDE <Locations.asm>
	INCLUDE <Locations2.asm>
	INCLUDE <Graphics.asm>
	INCLUDE <Graphics2.asm>
	INCLUDE <Text.asm>
	INCLUDE <Menus.asm>
	INCLUDE <Intro.asm>
	INCLUDE <Actions.asm>
	INCLUDE <Actions2.asm>
	INCLUDE <DrawJetman.asm>
	INCLUDE <MoveJetman.asm>
	INCLUDE <MoveEnemy.asm>
	INCLUDE <DrawLocation.asm>
	INCLUDE <Items.asm>
	
	INCLUDE <JetmanGraph.asm>
	INCLUDE <EnemyGraph.asm>
	INCLUDE <Flags.asm>
	
	SAVESNA "Heritage.sna",Start
	
	SAVEBIN "Heritage.bin",23900,41000